#include <stdio.h>			/* */
#include <stdarg.h>			/* */
#include <string.h>			/* */
#include <malloc.h>			/* */
#include <stdlib.h>			/* */
#include <unistd.h>			/* */
#include <time.h>			/* */

#include <errno.h>			/* */
#include <ctype.h>			/* */
#include <fcntl.h>			/* */
#include <pwd.h>			/* */	
#include <setjmp.h>			/* */		
#include <signal.h>			/* */
#include <stdio.h>			/* */
#include <stdlib.h>			/* */
#include <string.h>			/* */
#include <syslog.h>			/* */
#include <termios.h>			/* */
#include <unistd.h>			/* */
#include <utmp.h>			/* */

#include <sys/errno.h>			/* */
#include <sys/file.h>			/* */
#include <sys/ioctl.h>			/* */
#include <sys/param.h>			/* */
#include <sys/resource.h>		/* */
#include <sys/stat.h>			/* */
#include <sys/time.h>			/* */
#include <sys/types.h>			/* */
#include <sys/utsname.h>		/* */	
#include <sys/wait.h>			/* */
#include <dirent.h>
extern "C" {
#define PROTOTYPES	1
#include <md5global.h>			/* md5 definition */
#include <md5.h>			/* md5 functions */
};

#ifdef _ASPLINUX_
#include <time.h>			//
#endif 

/* __UCRP_CODE_FULL__ - define macro to include full code to binary file */
#define  __UCRP_CODE_FULL__


#ifdef  __UCRP_CODE_FULL__
#define __UCRP_CODE_MASTER__
#endif 						/* __UCRP_CODE_FULL__ */

#ifdef __UCRP_CODE_MASTER__
/* master mode */
#include <sys/types.h>		/* system types */
#include <sys/socket.h>		/* sockets */
#include <unistd.h>		/* select read write close */
#include <sys/time.h>		/* timeval */
#include <netdb.h>		/* gethostbyname */
#include <netinet/in.h>		/* sockaddr_in */
#include <netinet/tcp.h>	/* TCP_NODELAY */
#include <arpa/inet.h>		/* inet_addr */
#include <errno.h>		/* errno */
#endif 							/* __UCRP_CODE_MASTER__ */

#include "ucrp.h"

/* to disable all debug code undefine __UCRP_DEBUG__ macro */
#define __UCRP_DEBUG__			/* enable debug code */

#if !defined __UCRP_DEBUG__ || !defined __UCRP_COM_DEBUG__
/* not definde communication transfer -> uncomment partitial communication debugging */
#undef __UCRP_COM_ALLOC_DEBUG__		/* undefine channel allocation debugging */
#undef __UCRP_COM_READ_DEBUG__		/* undefine channel read debugging */
#endif

#define UCRP_USAGE \
"UCRP 1.12 (c) 2006-2009 Dmitriy I.Cherkashin, www.ucrouter.ru\n"  \
"email: dch@ucrouter.ru , divch@users.sourceforge.net , dch@ucrouter.com\n"  \
"phone: +8-909-936-8809; ICQ: 474-363-900;\n"  \
"This is not public software, you can't use this program without\n"  \
"license agreement, which available via option --license\n"  \
"with noted above author. To see license agreement use:\n"  \
"ucrp --license\n"  \
"  or\n"  \
"ucrp --license-ru\n"  \
"  for russian license translation.\n"  \

#define UCRP_LICENSE \
"UCRP 1.12 (c) 2006-2009 Dmitriy I.Cherkashin, www.ucrouter.ru\r\n"  \
"email: dch@ucrouter.ru , divch@users.sourceforge.net , dch@ucrouter.com\r\n"  \
"phone: +8-909-936-8809; ICQ: 474-363-900;\r\n"  \
"This program is free software with source codes\r\n"  \
"downloadable via internation communicational net.\r\n"  \
"If you have source codes of this software original or modified,\r\n"  \
"you must provide ability to free receive original source codes\r\n"  \
"of this software to another users even in internation communicational\r\n"  \
"net absens without any unusual aditional paynment exept\r\n" \
"downloading files from internation communicational net cost or\r\n" \
"mail cost.\r\n"

#define UCRP_LICENSE_RU \
"UCRP 1.12 (c) 2006-2009  ., www.ucrouter.ru\r\n" \
" : dch@ucrouter.ru,divch@users.sourceforge.net,dch@ucrouter.com\r\n"  \
": +8-909-936-8809; ICQ: 474-363-900;\r\n" \
"     \r\n" \
"      \r\n" \
" .\r\n" \
"       \r\n" \
"  ,     \r\n" \
"     \r\n" \
"     \r\n" \
"      \r\n" \
"       \r\n" \
"    \r\n" \
"     .\r\n"

/*  */

/* */
#define UCRP_BS   	     0x7f	/* Back Space Key */
#define UCRP_DEL 	 0x335b1b	/* Delete Key */

char * ucrp_version_number = "1.12";


/* command type */
#define UCRP_ENCRYPT 	 0x0001		/* encrypt file */
#define UCRP_DECRYPT 	 0x0002		/* decrypt file */
#define UCRP_INFO 	 0x0004		/* encrypted file info */

/* exit cmd */				/* */

#define UCRP_LIC	 0x0001 	/* print license agreement & exit */
#define UCRP_LICRU	 0x0002 	/* print license agreement, ru & exit */
#define UCRP_HELP	 0x0003 	/* print help usage & exit */
#define UCRP_VERSION	 0x0004		/* print version & exit */
#define UCRP_TODO	 0x0005		/* print todo note & exit */
#define UCRP_CHANGELOG	 0x0006		/* print change log & exit */
#define UCRP_MAN	 0x0007		/* print man page and exit */




#define UCRP_PASSWD_SIZE 	1024
#define UCRP_FILE_NAME_SIZE 	1024
char ucrp_passwd[UCRP_PASSWD_SIZE] = "";
char ucrp_pfile[UCRP_FILE_NAME_SIZE] = ""; /* passwd file */
char ucrp_hide_passwd = 1;		/* hide passwd flag */
int ucrp_hack = 5;			/* hack count */
u_int8_t ucrp_local = 0;		/* take executable files from local */
/* quiet mode, 1 - no print, 2 - only usage, todo, changelog */
char ucrp_quiet = 0;			/* */


int ucrp_cmd = 0;			/* ucrp command */
FILE * ucrp_fi = 0;			/* input file descriptor */
FILE * ucrp_fo = 0;			/* output file descriptor */
#define UCRP_FILE_NAME_SIZE	1024
char ucrp_ifile[UCRP_FILE_NAME_SIZE] = ""; /* input file name */
char ucrp_ofile[UCRP_FILE_NAME_SIZE] = ""; /* output file name */

/* output file name */
char ucrp_cdir[UCRP_FILE_NAME_SIZE] = "";  /* current dirrectory */  
char ucrp_pdir[UCRP_FILE_NAME_SIZE] = "";  /* previous current dirrectory */  

#define COMP_LEN 8192			/* compability buffer length */
#define KEY_LEN  8192			/* key buffer length */
u_char ucrp_comp_buf[COMP_LEN] = "";

#define __UCRP_XOR_ENABLE__		/* enable XOR algoritm */
#define __UCRP_ADD_ENABLE__		/* enable ADD algoritm */
#define __UCRP_ROT_ENABLE__		/* enable ROT algoritm */
#define __UCRP_TAB_ENABLE__		/* enable TAB algoritm */
#define __UCRP_ECC_ENABLE__		/* enable ECC algoritm */
/* BTS now RBTS ==== TODO ==== */
#define __UCRP_BTS_ENABLE__		/* enable BTS {bit swap algorithm} */
#define __UCRP_BEV_ENABLE__		/* enable BEV {bit even algorithm} */
#define __UCRP_XRE_ENABLE__		/* enable XRE xor enhanced */

#ifdef  __UCRP_XOR_ENABLE__
#define UCRP_XOR    	64				/* xor compatibility */
#endif 							/* __UCRP_XOR_ENABLE__ */

#ifdef  __UCRP_ADD_ENABLE__
#define UCRP_ADD    	65				/* add compatibility */
#endif 							/* __UCRP_ADD_ENABLE__ */

#ifdef  __UCRP_ROT_ENABLE__
#define UCRP_ROT    	66				/* byte rotate */
#endif 							/* __UCRP_ROT_ENABLE__ */

#ifdef  __UCRP_TAB_ENABLE__
#define UCRP_TAB    	67				/* byte table */
#endif 							/* __UCRP_TAB_ENABLE__ */

#ifdef  __UCRP_ECC_ENABLE__
#define UCRP_ECC    	68				/* ecc coding */
#endif  						/* __UCRP_ECC_ENABLE__ */

#ifdef __UCRP_BTS_ENABLE__
#define UCRP_BTS    	69				/* bit swapping algoritm */
#endif  						/* __UCRP_BTS_ENABLE__ */

/* 70, 71 -   TODO */
/* ==== TODO */
#ifdef __UCRP_BEV_ENABLE__
#define UCRP_BEV    	70				/* bit event */
#endif 							/* __UCRP_BEV_ENABLE__ */

#ifdef __UCRP_XRE_ENABLE__
#define UCRP_XRE    	71				/* xor enhanced */
#endif 							/* __UCRP_XRE_ENABLE__ */

#define UCRP_SBL    	72		/* source buffer size */
#define UCRP_SBL_LEN   	32		/* source buffer size length */
#define UCRP_DBL    	104		/* destination buffer size */
#define UCRP_DBL_LEN   	32		/* destination buffer size length */

u_char ucrp_key_buf[KEY_LEN] = "";
#define UCRP_XOR_BASE       0		/* xor value base */
#define UCRP_XOR_LEN        8		/* xor value length */
#define UCRP_ADD_BASE       8		/* add value base */
#define UCRP_ADD_LEN        8		/* add value legnth */
#define UCRP_ROT_BASE      16		/* ror value base */
#define UCRP_ROT_LEN        8		/* ror value length */
#define UCRP_TAB_BASE      24		/* tab value base */
#define UCRP_TAB_LEN        8		/* tab value length */
#define UCRP_ECC_BASE      32		/* ecc value base */
#define UCRP_ECC_LEN        8		/* ecc value length */
#define UCRP_BTS_BASE      40		/* bts value base {bit swapping} */
#define UCRP_BTS_LEN       64		/* bts value length {bit swapping} */
/* ==== TODO XRL_BASE,XRL_LEN,XRV_BASE, XRV_LEN */
/*
 -       xor
UCRP_LOW_NULL 0
UCRP_LOW_ADD => AD3
UCRP_LOW_ROT
UCRP_LOW_TAB
UCRP_LOW_BTS
*/

#define UCRP_XRL_BASE     104		/* xor mask change value low */
#define UCRP_XRL_LEN        5		/* xor mask change low length */
#define UCRP_XRV_BASE     109		/* xor mask change low value base */
#define UCRP_XRV_LEN        3		/* xor mask change low value length */

/* low value */
#define UCRP_LOW_NULL	    0		/* null low */
#define UCRP_LOW_AD3	    1		/* add low */
#define UCRP_LOW_ROT	    2		/* rot low */
#define UCRP_LOW_TAB	    3		/* tab low */
#define UCRP_LOW_BTS	    4		/* bts low */
#define UCRP_LOW_MAX	    4		/* low maximun value */

#define UCRP_MUL_LOW	    5		/* mul low */
#define UCRP_PWR_LOW        6		/* pwer low */
#define UCRP_SAR_LOW	    7		/* sar low */
#define UCRP_BEV_LOW	    8		/* bev low */
#define UCRP_MLL_LOW	    9		/* mll low */
#define UCRP_MOV_LOW	   10		/* mov low */
#define UCRP_LOW_11	   11		/* TODO */
#define UCRP_LOW_12	   12		/* TODO */
#define UCRP_LOW_13	   13		/* TODO */
#define UCRP_LOW_14	   14		/* TODO */
#define UCRP_LOW_15	   15		/* TODO */
#define UCRP_LOW_16	   16		/* TODO */
#define UCRP_LOW_17	   17		/* TODO */
#define UCRP_LOW_18	   18		/* TODO */
#define UCRP_LOW_19	   19		/* TODO */
#define UCRP_LOW_20	   20		/* TODO */
#define UCRP_LOW_21	   21		/* TODO */
#define UCRP_LOW_22	   22		/* TODO */
#define UCRP_LOW_23	   23		/* TODO */
#define UCRP_LOW_24	   24		/* TODO */
#define UCRP_LOW_25	   25		/* TODO */
#define UCRP_LOW_26	   26		/* TODO */
#define UCRP_LOW_27	   27		/* TODO */
#define UCRP_LOW_28	   28		/* TODO */
#define UCRP_LOW_29	   29		/* TODO */
#define UCRP_LOW_30	   30		/* TODO */
#define UCRP_LOW_31	   31		/* TODO */


#define UCRP_TABLE_BASE  (256 * 8)	/* 1024  */
#define UCRP_TABLE_LEN   (256 * 8)

/* source buffer size */
#define UCRP_SRC_SIZE 0x10000
/* destination buffer size */
#define UCRP_BUF_SIZE (UCRP_SRC_SIZE + ((UCRP_SRC_SIZE / 256) * 3))

static u_int32_t ucrp_src_buf_size = UCRP_SRC_SIZE;
static u_int32_t ucrp_dst_buf_size = UCRP_BUF_SIZE;

static u_char * ucrp_src = 0;		/* source buffer */
static u_char * ucrp_dst = 0;		/* destination buffer */

/* */
#define UMSG_PS 		"%s"
#define UMSG_EMP 		""
#define	UMSG_CRNL 		"\r\n"
#define	UMSG_PC 		"%c"
#define	UMSG_02X 		"%02x"
#define	UMSG_PRESS_ANY_KEY	"Press any key ..."
#define	UMSG_REC_SIG	  	"Received signal %d. Terminating.\r\n"
#define	UMSG_REC_SIGPIPE 	"SIGPIPE - connection losed\r\n"
#define	UMSG_REC_UNK_SIG 	"Received unknown signal %d\r\n"
#define	UMSG_VERSION 		"\r\nVersion : %s\r\n"
#define	UMSG_CHANGELOG \
    "\nChangeLog\n"	\
    "1. - 2008\\03\\17 \%Zm \%E format\n" \
    "2. - 2009\\05\\30 added md5 sum\n"	\
    "3. - \n"	\
    "4. - \n"	\
    "5. - \n"	\
    "6. - \n"	\
    "7. - \n"	\
    "8. - \n"	\
    "9. - \n"	\
    "10. - \n"	\
    "11. - \n"	\
    "12. - \n"	\
    "13. - \n"	\
    "14. - \n"	\
    "15. - \n"	\
    "16. - \n"	\
    "17. - \n"	\
    "18. - \n"	\
    "19. - \n"	\
    "20. - \n"	\
    "21. - \n"	\
    "22. - \n"	\
    "23. - \n"	\
    "24. - \n"	\
    "25. - \n"	\
    "26. - \n"	\
    "27. - \n"	\
    "28. - \n"

#define UMSG_HFILE 		"/var/log/ucrp_history"
#define UMSG_RB 		"r+b"
#define UMSG_HFILE_EMPTY	"Empty history file"
#define UMSG_HISTORY_VER	"ucrp v1.1"
#define UMSG_WB 		"w+b"
#define UMSG_BS 		"\b"
#define UMSG_SP 		" "
#define UMSG_HFILE_OPEN_ERROR	"File /var/log/ucrp_history open error\n\r"
#define UMSG_HFILE_EN_OPEN_ERROR "File /var/log/ucrp_history_en open error\n\r"
#define UMSG_HFILE_ALLREDY_EN 	"History allready encrypted\n\r"
#define UMSG_HFILE_ALLREDY_DE 	"History allready decrypted\n\r"
#define UMSG_HFILE_EN		"/var/log/ucrp_history_en"
#define UMSG_STDIN_ERROR 	"\r\nBad stdin descriptor\r\n"
#define UMSG_TCGETATTR_STDIN_ERROR "\r\n-tcgetattr stdin error: (%d)\r\n"
#define UMSG_TCSETATTR_STDIN_ERROR "\r\ntcsetattr stdin error : (%d)\r\n"
#define UMSG_SELECT_ERROR	"\r\nselect error : (%d)\r\n"
#define UMSG_STDIN_READ_ERROR	"\r\nstdin read error : (%d)\r\n"
#define UMSG_O_NONBLOCK_ERROR 	"set O_NONBLOCK mode error\r\n"
#define UMSG_URANDOM_FILE_NAME	"/dev/urandom"
#define UMSG_FORM_CHANGE_DIR	" --change-dir %s"
#define UMSG_INFO_VERSION	"version %s\n"
#define UMSG_INFO_XOR		"xor %s %d\n"
#define UMSG_INFO_XRE		"xre %s %d\n"
#define UMSG_INFO_ON		"on"
#define UMSG_INFO_OFF		"off"
#define UMSG_LOW_NULL		"null"
#define UMSG_LOW_AD3		"add"
#define UMSG_LOW_ROT		"rot"
#define UMSG_LOW_TAB		"tab"
#define UMSG_LOW_BTS		"bts"
#define UMSG_LOW_UNKN		"unkn"
#define UMSG_HASH 		"hash:"
#define UMSG_TTAB		"ttab :"
#define UMSG_BTTB		"bttb :"
#define UMSG_RTAB 		"rtab :"
#define UMSG_INFO_XRL		"xrl %s %d\n"
#define UMSG_INFO_XRV   	"xrv %d\n"
#define UMSG_INFO_ADD		"add %s %d\n"
#define UMSG_INFO_ROT 		"rot %s %d\n"
#define UMSG_INFO_TAB 		"tab %s %d\n"
#define UMSG_INFO_ECC 		"ecc %s %d\n"
#define UMSG_INFO_BTS 		"bts %s "
#define UMSG_INFO_TTAB 		"translate table:\n"
#define UMSG_INFO_SBL 		"source block length %d {0x%x}\n"
#define UMSG_INFO_DBL 		"destination block length %d {0x%x}\n"
#define UMSG_INFO_TRT 		"translate table:\n"
#define UMSG_XOR_ERR  		"xor algs error\n"

/* */
extern volatile int kill_link;		/* > 1, exit flag from select loop */
extern volatile int ucrp_sig_pipe_flag;	/* */
extern volatile int sig_chld_flag;
extern volatile u_int8_t sig_alrm;	/* > 1, exit flag from select loop */
extern volatile u_int8_t debug_alrm;	/* print debug note in alarm handler */

/* error message */
#if 1
int ucrp_error(const char *frmt, ...) 
{
 if(ucrp_quiet == 1) {			/* no messages in quiet mode */
    return(1);
 } else {
    char pbuf[512];			/* message buffer */

/* from command args */
    va_list valt;				/* argument list */
    va_start(valt, frmt);			/* init argument list */
    vsnprintf(pbuf, sizeof(pbuf), frmt, valt);	/* */
    va_end(valt);				/* */
    fprintf(stderr, UMSG_PS, pbuf);	/* print error message to stderr */	
    fflush(stderr);			
    return(1);
 }
}
#else
#define ucrp_error(...) 
#endif							/* */


/* print debug message & exit */

int ucrp_debug(const char *frmt, ...) 
{
 if(ucrp_quiet == 1) {			/* no messages in quiet mode */
    return(1);
 } else {
    char pbuf[1024];			/* message buffer */

/* from command args */
    va_list valt;				/* argument list */
    va_start(valt, frmt);			/* init argument list */
    vsnprintf(pbuf, sizeof(pbuf), frmt, valt);	/* */
    va_end(valt);				/* */

    fprintf(stderr, UMSG_PS, pbuf);	/* print error message to stderr */	
    fflush(stderr);			
    return(1);
 }
}


#if 1
int ucrp_printf( const char *frmt, ... ) 
{
 static u_int8_t pmode = 0;		/* print mode */
 static int prow = 0; 			/* screen row */
 static int pcol = 0;			/* column number */
 static char pbuf[4096];		/* print buffer */
 u_int8_t nmode = 0;			/* next print mode */
 va_list valt;				/* argument list */

 if(ucrp_quiet == 1) {	
    return(1);
 }
/* */
 if(nmode != pmode) {			/* change mode */
    if(pmode == 0) {			
/* previous mode normal -> reset screen coordinates */
	prow = 0; 			/* screen row */
	pcol = 0;			/* column number */
    }

    pmode = nmode;			/* save next mode */
 } 

/* */
 va_start(valt, frmt);			/* init argument list */
 vsnprintf(pbuf, sizeof(pbuf), frmt, valt);
 va_end(valt);

 if(pmode == 0) {
/* print in normat mode */
    fprintf(stdout, UMSG_PS, pbuf);
    fflush(stdout);
 } else 
 if(ucrp_quiet == 2) {
/* quiet mode */
    fprintf(stdout, UMSG_PS, pbuf);
    fflush(stdout);
 } else {
    int ppos;				/* buffer position */
    ppos = 0;				/* start buffer pos */
    while(ppos < (int) sizeof(pbuf)) {
	char ch;
	ch = *(pbuf + ppos);		/* read character */
	if(ch == '\0') {		/* end of string */
    	    break;
	}
	if(ch == '\n') {
    	    pcol = 0;			/* column number */
    	    prow += 1;			/* */
    	    fprintf(stdout, UMSG_CRNL);	/* print character */
	} else
	if(ch == '\t') {
    	    int cnt;
    	    cnt = pcol;
    	    pcol = (((pcol + 8) / 8) * 8);
    	    cnt = pcol - cnt;
    	    while(cnt-- > 0) {
    		fprintf(stdout, UMSG_PC, ' ');
	    }
	} else {
	    pcol += 1;
	    fprintf(stdout, UMSG_PC, ch);
	}
	ppos++;
	if(pcol >= 80) {
    	    pcol -= 80;
    	    prow += 1;
	}

	if(prow >= 24) {
	/* print cr lf */
	    if(ch != '\n') {
    		fprintf(stdout, UMSG_CRNL);
	    }
    	    fprintf(stdout, UMSG_PRESS_ANY_KEY);
    	    fflush(stdout);
	    ucrp_select(&ch, 1, 0, 0);	/* read character, no echo, no wait */
    	    fprintf(stdout, UMSG_CRNL);	/* print cr lf */
    	    pcol = 0;			/* new column */
	    prow = 0;			/* new row */
	}
    }

    /* */
    fflush(stdout);

    if(pmode == 1) {		
/* switch from single page mode to normal */
	pmode = 0;
    }
 }
 return(1);
}

#else /* 0 */
#define ucrp_printf printf
#endif							


/* form file full path */

int ucrp_path(char * buf, int bsize, char * name)
{
 char tname[128];			/* temporary name */		
 struct stat sbuf;			/* file status buffer */
 int rvl;				/* return value */

/* */
 rvl = 1;

 snprintf(tname, sizeof(tname), "/sbin/%s", name);	/* search in sbin */
 if(lstat(tname,&sbuf) < 0) {		 		/* read file status */
    snprintf(tname, sizeof(tname), "/bin/%s", name);	/* search in bin */
    if(lstat(tname,&sbuf) < 0) {
	snprintf(tname, sizeof(tname), "/usr/bin/%s", name); /* search in /usr/bin */
	if(lstat(tname,&sbuf) < 0) {
	    rvl = 0;			/* file not found -> clear return code */
	}
    }
 } 

 if(rvl == 0) {
 /* file not found */
    if(buf != 0 && bsize > 0) {		/* clear file name buffer */
	*(buf + 0) = '\0';
    }
    return(-1);
 }

 if(S_ISREG(sbuf.st_mode)) {
 /* regular file -> from file name */
    if(buf != 0 && bsize > 0) {
	snprintf(buf, bsize, "%s", tname);
    }
    return(1);
 } else {
    return(0);
 }
} 












/* print help message */

int ucrp_usage(int scmd)
{
/* */
 if(ucrp_quiet == 1) {
    ucrp_quiet = 2;
 }

    ucrp_printf(
	UCRP_USAGE
	"Usage : ucrp [options] <input file> [<output file>]\n"
	"where options may be:\n"
	"--license      - show this program license agreement\n"
	"--license-ru   - show this program license agreement translated for russian language\n"
	"--encrypt      - encrypt file\n"
	"--decrypt      - decrypt file\n"
	"--passwd | request - password\n"
	"--hide-passwd  - hide passwd\n"
	"--show-passwd  - show passwd\n"
	"--block-size   - block size\n"
	"--change-dir   - change current directory\n"
	"--info         - print encrypt file info message and exit\n"
	"--quiet        - quiet mode\n"
	"--version      - print version and exit\n"
	"--todo         - print todo and exit\n"
	"--changelog    - print changelog and exit\n"
	"--man          - print man page and exit\n"
	"--help         - print help note and exit\n"
    );
/* */
 return(1);
}

int ucrp_license(void)
{
/* cutted version - if you have source codes of this software,
you must provide this ability to another users */
 ucrp_printf(UCRP_LICENSE);
 return(1);
}

int ucrp_license_ru(void)
{
/*   -        ,
        */
 ucrp_printf(UCRP_LICENSE_RU);
 return(1);
}

/* print version */
int ucrp_version(void)
{
 ucrp_printf(UMSG_VERSION, ucrp_version_number);
 return(1);
}

/* print todo note */
int ucrp_todo(void)
{
 char * msg = 

    "";
/* */
 if(ucrp_quiet == 1) {
    ucrp_quiet = 2;
 }

 ucrp_printf(msg);
 return(1);
}

/* print changelog note */
int ucrp_changelog(void)
{
 if(ucrp_quiet == 1) {
    ucrp_quiet = 2;
 }

 ucrp_printf(
    UMSG_CHANGELOG
 );
 return(1);
}


/* */
int ucrp_man(int scmd)
{
 ucrp_printf(
    "\nman\n"
    "\n"
 );
 return(1);
}

int ucrp_init(void)
{
 int pos;
 for(pos = 0; pos < (int) sizeof(ucrp_passwd); ++pos) {
    ucrp_passwd[pos] = 0;
 }
 return(1);
}

int ucrp_key(u_int32_t key, u_char * buf, int len)
{
 if(buf == 0 || len == 0) {
    return(0);
 }

 if(key <= 0xFF) {
/* key length - one byte */
    u_int8_t bchr;			/* buffer character */
    bchr = *(buf + 0);			/* read characeter from buffer */
    if(bchr == key) {			
        return(2);
    } else {
        return(0);			/* one byte key string not found in buffer */
    }
 } else 
 if(key <= 0xFFFF) {
/* two bytes character */
    if(len < 2) {			/* */
	return(0);
    } else {
        u_int16_t bchr;			/* two bytes character */
	/* calculate two bytes character */
	bchr = 
	    ( (((u_int32_t) *(buf + 1)) << 8) | 
	       ((u_int32_t) *(buf + 0)) );
	if(key == bchr) {		/* two bytes character found in buffer */
	    return(3);
	} else {
	    return(0);
	} 
    }
 } else 
 if(key <= 0xFFFFFF) {
/* free bytes character */

    if(len < 3) {
	return(0);
    } else {
        u_int32_t bchr;
	bchr = ( (((u_int32_t) *(buf + 2)) << 16) | 
	    (((u_int32_t) *(buf + 1)) << 8) | ((u_int32_t) *(buf + 0)) );
	if(key == bchr) {
	    return(4);
	} else {
	    return(0);
	}
    }
 } else {
/* for bytes character */
    if(len < 4) {
	return(0);
    } else {
	u_int32_t bchr;
	bchr = 
	( (((u_int32_t) *(buf + 3)) << 24) | 
	  (((u_int32_t) *(buf + 2)) << 16) | 
	  (((u_int32_t) *(buf + 1)) << 8) | 
	   ((u_int32_t) *(buf + 0)) );
	if(key == bchr) {
	    return(1);
	} else {
	    return(0);
	}
    }
 }
}

#if 1
/* echo = 0 - no echo, 1 - echo, 2 - '*' echo */ 
/* wait - 0 = no wait, 1 = wait */
/* ==== TODO ==== (-1) error, ECS */

int ucrp_select(char * buf, int len, int echo, int wait)
{
 fd_set r_fds; 				/* read mask */
 FD_ZERO(&r_fds);			/* clear read mask */

/* read stdin file descriptor */

 int stdinfd;
 stdinfd = fileno(stdin);
 if(stdinfd < 0 || stdinfd >= (int)sizeof(r_fds) * 8) {
    ucrp_error(UMSG_STDIN_ERROR);
    return(0);
 }

/* */
 int maxfd;				/* maximum descriptor number */
 maxfd = stdinfd;

#define TC_GET_SET_ATTR
#ifdef TC_GET_SET_ATTR
 struct termios stdintios;		
 if(tcgetattr(stdinfd, &stdintios) < 0) {
    ucrp_error(UMSG_TCGETATTR_STDIN_ERROR, errno);
    return(0);
 }

 struct termios tios;	
 tios = stdintios;
 cfmakeraw(&tios);

// 
 if(
    tcsetattr(
	stdinfd, 
	TCSANOW, 			/* set immedeatly */
	&tios
    ) < 0) {
    ucrp_error(UMSG_TCSETATTR_STDIN_ERROR, errno);
    return(0);
 }        
#endif 

 int stdinflag;				/* flags */
 stdinflag = fcntl(stdinfd ,F_GETFL,0);	/* read stdin flags */
 if(fcntl(stdinfd , F_SETFL, O_NONBLOCK) < 0) {	
/* set non block mode error */
    ucrp_error("Set nonblock mode for standart input error\n");
    return(0);			/* error */
 }

// 
 int pos;				/* destination buffer position */
 int more;				/* more flag */
 int rvl;				/* return code */

/* */
 pos = 0;				/* buffer position */
 more = 1;				/* more flag */
 rvl = 1; 				/* return value */


 while(more) {
    FD_SET	(
	stdinfd	,			/* stdin descriptor */
	& r_fds				/* read descriptor */
    );     

// 
    struct timeval tval;	
    if(wait > 0) {
        tval.tv_sec = wait;		/* 1sec delay */
    } else {
        tval.tv_sec = 0;
    }
    tval.tv_usec = 0;

// 
//printf("select\n");

    int cnt;
    cnt = select(
        maxfd + 1,			/* descriptors in mask */
	& r_fds, 			/* read mask */
	0, 				/* write mask */
	0, 				/* exeption mask */
	& tval
    );

//printf("end %d\n", cnt);

    if(kill_link > 1) {			/* received more then one term signal */
	break;
    }

    if(cnt <= 0) {
	if(cnt < 0) {
	/* select error */
	    ucrp_error(UMSG_SELECT_ERROR,  errno);
    	    rvl = 0;  
    	    break;
        } else {
	/* no events */
	    if(wait == 0) {
		break;
	    } else {
    		continue;
	    }
        }
    }


    u_char rbuf[32];
    rbuf[0] = 0;

    if(FD_ISSET(stdinfd,& r_fds)) {
	cnt = read(stdinfd, rbuf, sizeof(rbuf));
	if(kill_link > 1) {			/* receive more then one */
	    break;
	} 
	if(cnt < 0) {
	    ucrp_error(UMSG_STDIN_READ_ERROR, errno);
	    rvl = 0;  
	    break;
	}


	if(cnt <= 0) {
	    continue;
	}

	int ps = 0;
        while(ps < cnt) {
	    u_char pkey;		/* precced key */	
	    u_char plen;		/* pressed key length */
	    u_char ch;			/* readed character */
	
	    plen = ucrp_key(UCRP_BS, rbuf, cnt);
	    if(plen > 0) { 
		pkey = 1;		/* BS key */
		ps += plen;		/* next buffer position */
	    } else {
		plen = ucrp_key(UCRP_DEL, rbuf, cnt);
		if(plen > 0) { 
		    pkey = 1;		/* DEL key */
		    ps += plen;		/* next buffer position */
		} else {
		    pkey = 0;		
		}
	    }

	    if(pkey == 1) {
		ch = '\b';
	    } else {
		ch = rbuf[ps];		/* read character from buffer */
		ps += 1;    
	    } 
	    
	    if(ch == '\b' || ch == '\b') {
	    /* back space */
		if(pos > 0) {
		    pos -= 1;

		    if(buf != 0) {
		        if(pos < len) {
			    *(buf + pos) = '\0';
			}
		    }
			
		    if((echo == 1) || (echo == 2)) {
			ucrp_printf(UMSG_BS);
			ucrp_printf(UMSG_SP);
			ucrp_printf(UMSG_BS);
		    }
		}
	    } else
	    if((ch == '\n') || (ch == '\r')) {
	    /* enter */
		more = 0;
		ucrp_printf(UMSG_CRNL);
	    } else
	    if((ch == 0x1B)) {
	    /* escape key */
		more = 0;
		pos = 0;
		ucrp_printf("{Canceled}");
	    } else {
	    /* valid character */
	        if(buf != 0) {
		    if(pos < len) {
			if(pos >= 0) {
			    *(buf + pos) = ch;
			}
		    }
		}
/* */
		++pos;
/* */
		if(echo == 1) {
		    ucrp_printf(UMSG_PC,ch);
		} else 
		if(echo == 2) {
		    ucrp_printf(UMSG_PC,'*');
		} else {
		}
	    }
	}
	
	if(wait == 0) {			/* no wait mode */
	    more = 0;			/* clear more flag */
	}
    }
 }

 if(buf != 0) {
    if(pos > len) {
	pos = len - 1;
    }
    if(pos > 0) {
        *(buf + pos) = '\0';
    }
 }

/* */
 if(fcntl(stdinfd , F_SETFL, stdinflag) < 0) {	
    ucrp_error("Restore flags for standart input error\n");
    return(0);			/* error */
 }

#ifdef TC_GET_SET_ATTR
 /* */
 if(tcsetattr(stdinfd, TCSANOW, &stdintios) < 0) {

    ucrp_error(UMSG_TCSETATTR_STDIN_ERROR, errno);
    rvl = 0;
 }        
#endif 
 /* */
 return(pos);
}
#else

/* echo = 0 - no echo, 1 - echo, 2 - '*' echo */ 
/* wait - 0 = no wait, 1 = wait */

int ucrp_select(char * buf, int len, int echo, int wait)
{
 fd_set r_fds; 
 FD_ZERO(&r_fds);

// read stdin file descriptor //////////////////////////////////////////////

 int stdinfd;
 stdinfd = fileno(stdin);
 if(stdinfd < 0 || stdinfd >= (int)sizeof(r_fds) * 8) {
    ucrp_error(UMSG_STDIN_ERROR);
    return(0);
 }

 int maxfd;
 maxfd = stdinfd;

 struct termios stdintios;	
 if(tcgetattr(stdinfd, &stdintios) < 0) {
    ucrp_error(UMSG_TCGETATTR_STDIN_ERROR, errno);
    return(0);
 }

 struct termios tios;	
 tios = stdintios;
 cfmakeraw(&tios);

// 
 if(tcsetattr(stdinfd, TCSAFLUSH, &tios) < 0) {
    ucrp_error(UMSG_TCSETATTR_STDIN_ERROR, errno);
    return(0);
 }        

// 
 int pos;				/* destination buffer position */
 int more;				/* more flag */
 int rvl;				/* return code */
//
 pos = 0;
 more = 1;
 rvl = 1; 


 while(more) {
    FD_SET	(
	stdinfd	,			/* stdin descriptor */
	& r_fds				/* read descriptor */
    );     

// 
    struct timeval tval;	
    tval.tv_sec  = 1;			/* 1sec delay */
    tval.tv_usec = 0;

// 
    int cnt;
    cnt = select(
        maxfd + 1,
	& r_fds, 
	0, 
	0, 
	& tval
    );

    if(kill_link > 1) {			/* receive more then one signal */
	break;
    }

    if(cnt <= 0) {
	if(cnt < 0) {
	    ucrp_error(UMSG_SELECT_ERROR,  errno);
    	    rvl = 0;  
    	    break;
        } else {
    	    continue;
        }  
    }

    u_char rbuf[32];
    rbuf[0] = 0;

    if(FD_ISSET(stdinfd,& r_fds)) {

	cnt = read(stdinfd, rbuf, sizeof(rbuf));
	if(kill_link > 1) {		/* receive more then one signal */
	    break;
	} 
	if(cnt < 0) {
	    ucrp_error(UMSG_STDIN_READ_ERROR, errno);
	    rvl = 0;  
	    break;
	}


	if(cnt <= 0) {
	    continue;
	}

	int ps = 0;
        while(ps < cnt) {
	    u_char pkey;		/* precced key */	
	    u_char plen;		/* pressed key length */
	    u_char ch;			/* readed character */
	
	    plen = ucrp_key(UCRP_BS, rbuf, cnt);
	    if(plen > 0) { 
		pkey = 1;		/* BS key */
		ps += plen;		/* next buffer position */
	    } else {
		plen = ucrp_key(UCRP_DEL, rbuf, cnt);
		if(plen > 0) { 
		    pkey = 1;		/* DEL key */
		    ps += plen;		/* next buffer position */
		} else {
		    pkey = 0;		
		}
	    }

	    if(pkey == 1) {
		ch = '\b';
	    } else {
		ch = rbuf[ps];		/* read character from buffer */
		ps += 1;    
	    } 
	    
	    if(ch == '\b' || ch == '\b') {
	    /* back space */
		if(pos > 0) {
		    pos -= 1;

		    if(buf != 0) {
		        if(pos < len) {
			    *(buf + pos) = '\0';
			}
		    }
			
		    if((echo == 1) || (echo == 2)) {
			ucrp_printf(UMSG_BS);
			ucrp_printf(UMSG_SP);
			ucrp_printf(UMSG_BS);
		    }
		}
	    } else
	    if((ch == '\n') || (ch == '\r')) {
	    /* enter */
		more = 0;
		ucrp_printf(UMSG_CRNL);
	    } else {
	    /* valid character */
	        if(buf != 0) {
		    if(pos < len) {
			if(pos >= 0) {
			    *(buf + pos) = ch;
			}
		    }
		}
/* */
		++pos;
/* */
		if(echo == 1) {
		    ucrp_printf(UMSG_PC,ch);
		} else 
		if(echo == 2) {
		    ucrp_printf(UMSG_PC,'*');
		} else {
		}
	    }
	}
	
	if(wait == 0) {			/* no wait mode */
	    more = 0;			/* clear more flag */
	}
    }
 }

 if(buf != 0) {
    if(pos > len) {
	pos = len - 1;
    }
    if(pos > 0) {
        *(buf + pos) = '\0';
    }
 }

 /* */
 if(tcsetattr(stdinfd, TCSAFLUSH, &stdintios) < 0) {

    ucrp_error(UMSG_TCSETATTR_STDIN_ERROR, errno);
    rvl = 0;
 }        

 /* */
 return(pos);
}
#endif

/* init random */
int ucrp_random_fd = -1;		/* /dev/random file descriptor */
int ucrp_urandom_fd = -1;		/* /dev/urandom file descriptor */
int ucrp_random_init(void)
{
/* open random in nonblock mode */
 ucrp_random_fd = open(UMSG_URANDOM_FILE_NAME , (O_RDONLY | O_NONBLOCK));
 if(ucrp_random_fd != -1) {
    int fdflags;
    fdflags = fcntl(ucrp_random_fd, F_GETFL);	
    if(fdflags == -1 || fcntl(ucrp_random_fd, F_SETFL, fdflags | O_NONBLOCK) < 0) {
	ucrp_error(UMSG_O_NONBLOCK_ERROR);
    }
 }

 
/* open urandom in nonblock mode */
 ucrp_urandom_fd = open(UMSG_URANDOM_FILE_NAME, (O_RDONLY | O_NONBLOCK));
 if(ucrp_urandom_fd != -1) {
    int fdflags;
    fdflags = fcntl(ucrp_urandom_fd, F_GETFL);	
    if(fdflags == -1 || fcntl(ucrp_urandom_fd, F_SETFL, fdflags | O_NONBLOCK) < 0) {
	ucrp_error(UMSG_O_NONBLOCK_ERROR);
    }
 }

 if((ucrp_random_fd != -1) || (ucrp_urandom_fd != -1)) {
    return(1);
 } else {
    return(0);
 }
}

/* close random files */

int ucrp_random_close(void)
{
 if(ucrp_random_fd != -1) {
    close(ucrp_random_fd);		/* close randowm file */
    ucrp_random_fd = -1;		
 }

 if(ucrp_urandom_fd != -1) {
    close(ucrp_urandom_fd);		/* close urandowm file */
    ucrp_urandom_fd = -1;
 }
 return(1);
}

/* read randowm byte */
u_char ucrp_random(void)
{
 static u_char ch = 0;
 if(ucrp_random_fd != -1) {
    if(read(ucrp_random_fd, &ch, 1) == 1) {
	return(ch);
    } 
 }

 if(ucrp_urandom_fd != -1) {
    if(read(ucrp_urandom_fd, &ch, 1) == 1) {
	return(ch);
    } 
 }
 
 ch += 1;
 return(1); 
}

/* read/write compatibility bit */
int ucrp_comp(int flag, int val)
{
 int byte;				/* byte number */
 int bit;				/* bit number */

 byte = (flag / 8);			/* byte */
 bit = (flag & 0x7);			/* bit */
 if(byte >= (int)sizeof(ucrp_comp_buf)) {
    return(0);
 }

 if(val < 0) {
/* read bit value */
    return( ((ucrp_comp_buf[byte] >> (7-bit)) & 0x1) );
 } else {
    if(val) {
	ucrp_comp_buf[byte] |=  (0x80 >> bit);
    } else {
	ucrp_comp_buf[byte] &= ~(0x80 >> bit);
    }
    return(val);
 }
}

/* read/write compatibility value */
int ucrp_comp_val(int flag, int len, int val)
{
 if(val < 0) {
/* read */
    val = 0;
    while(len > 0) {
	val <<= 1;			/* left shift */
	val |= ucrp_comp(flag, -1);	/* read bit */
	flag += 1;			/* next bit number */
	len  -= 1;			/* remain bits */
    }
    return(val);
 } else {
    while(len > 0) {
	if( (val & (1 << (len - 1))) != 0 ) {
	    ucrp_comp(flag,1);
	} else {
	    ucrp_comp(flag,0);
	}

	flag += 1;			/* next bit number */
	len  -= 1;			/* bits remain */
    }	
    return(val);
 }
}

/* init compatibylity buffer */
int ucrp_comp_init(void)
{
/* clear compatibility buffer */
 int cpos;
 for(cpos = 0; cpos < (int)sizeof(ucrp_comp_buf); ++cpos) {
    ucrp_comp_buf[cpos] = 0;
 }
/* program name */
 ucrp_comp_buf[0] = 'u';		/* uenc 1.0 */
 ucrp_comp_buf[1] = 'e';
 ucrp_comp_buf[2] = 'n';
 ucrp_comp_buf[3] = 'c';
 ucrp_comp_buf[4] = ' ';
 ucrp_comp_buf[5] = '1';
 ucrp_comp_buf[6] = '.';
 ucrp_comp_buf[7] = '0';

#ifdef __UCRP_XOR_ENABLE__
 ucrp_comp(UCRP_XOR, 1);		/* xor compatibility */
#endif 					/* __UCRP_XOR_ENABLE__ */

#ifdef __UCRP_ADD_ENABLE__
 ucrp_comp(UCRP_ADD, 1);		/* add compatibility */
#endif 					/* __UCRP_ADD_ENABLE__ */

#ifdef __UCRP_ROT_ENABLE__
 ucrp_comp(UCRP_ROT, 1);		/* byte rotate */
#endif 					/* __UCRP_ROT_ENABLE__ */

#ifdef __UCRP_TAB_ENABLE__
 ucrp_comp(UCRP_TAB, 1);		/* byte table */
#endif 					/* __UCRP_TAB_ENABLE__ */

#ifdef __UCRP_ECC_ENABLE__
 ucrp_comp(UCRP_ECC, 1);		/* ecc coding */	
#endif 					/* __UCRP_ECC_ENABLE__ */

#ifdef __UCRP_BTS_ENABLE__
 ucrp_comp(UCRP_BTS, 1);		/* enable BTS {byte swapping} */	
#endif 					/* __UCRP_BTS_ENABLE__ */

#ifdef __UCRP_XRE_ENABLE__
 ucrp_comp(UCRP_XRE, 1);		/* xor extended compatibility */
#endif 					/* __UCRP_XRE_ENABLE__ */

/* write source buffer size to compatibility buffer */
 ucrp_comp_val(UCRP_SBL, UCRP_SBL_LEN, ucrp_src_buf_size);
/* write destination buffer size to compatibility buffer */
 ucrp_comp_val(UCRP_DBL, UCRP_DBL_LEN, ucrp_dst_buf_size);

/* */
 return(1);
}

/* check compatibility buffer */

int ucrp_comp_check(void)
{
 if(
    (ucrp_comp_buf[0] != 'u') ||	/* uenc 1.0 */
    (ucrp_comp_buf[1] != 'e') ||
    (ucrp_comp_buf[2] != 'n') ||
    (ucrp_comp_buf[3] != 'c') ||
    (ucrp_comp_buf[4] != ' ') ||
    (ucrp_comp_buf[5] != '1') ||
    (ucrp_comp_buf[6] != '.') ||
    (ucrp_comp_buf[7] != '0')
 ) {
    return(0);				
 } else {
    return(1);				/* uenc 1.0 file */
 }
}

/* read bit from key buffer */
int ucrp_key(int flag,int val)
{
 int byte;				/* byte number */
 int bit;				/* bit number */

 byte = (flag / 8);			/* byte */
 bit = (flag & 0x7);			/* bit */
 if(byte >= (int) sizeof(ucrp_key_buf)) {
    return(0);
 }

 if(val < 0) {
/* read bit value */
    return( ((ucrp_key_buf[byte] >> (7-bit)) & 0x1) );
 } else {
    if(val) {
	ucrp_key_buf[byte] |=  (0x80 >> bit);
    } else {
	ucrp_key_buf[byte] &= ~(0x80 >> bit);
    }
    return(val);
 }
}

/* read value from key buffer */
int ucrp_key_val(int flag,int len, int val)
{
 if(val < 0) {
    val = 0;
    while(len > 0) {
	val <<= 1;
	val |= ucrp_key(flag, -1);
	flag += 1;
	len  -= 1;
    }
    return(val);
 } else {
    while(len > 0) {
	if((val & (1 << (len - 1))) != 0) {
	    ucrp_key(flag,1);
	} else {
	    ucrp_key(flag,0);
	}
	flag += 1;
	len  -= 1;
    }	
    return(val);
 }
}

/* init key buffer */

int ucrp_key_init(void)
{
 int pos;
 for(pos = 0; pos < (int)sizeof(ucrp_key_buf); ++pos) {
    ucrp_key_buf[pos] = 0;
 }

 u_char xor_val;			/* xor */
 u_char add_val;			/* add */
 u_char rot_val;			/* rot */
 u_char tab_val;			/* tab */
 u_char ecc_val;			/* ecc */

 xor_val =  ucrp_random();		/* xor value */
 add_val =  ucrp_random();		/* */
 rot_val = (ucrp_random() & 0x7);	/* */
 tab_val =  ucrp_random();		/* */
 ecc_val =  ucrp_random();		/* */

/* byte algs enable flag */
#if defined __UCRP_XOR_ENABLE__ || defined __UCRP_XRE_ENABLE__
/* defined xor or xre algorithm */
 ucrp_key_val(UCRP_XOR_BASE,UCRP_XOR_LEN,xor_val); 	/* xor value */	
#endif 							/* __UCRP_XOR_ENABLE__ */

#ifdef __UCRP_ADD_ENABLE__
 ucrp_key_val(UCRP_ADD_BASE,UCRP_ADD_LEN,add_val);	/* add value */
#endif 							/* __UCRP_ADD_ENABLE__ */
#ifdef __UCRP_ROT_ENABLE__					
 ucrp_key_val(UCRP_ROT_BASE,UCRP_ROT_LEN,rot_val);	/* rotate value */
#endif 							/* __UCRP_ROT_ENABLE__	*/
#ifdef __UCRP_TAB_ENABLE__		
 ucrp_key_val(UCRP_TAB_BASE,UCRP_TAB_LEN,tab_val);
#endif 							/* __UCRP_TAB_ENABLE__	*/
#ifdef __UCRP_ECC_ENABLE__		
 ucrp_key_val(UCRP_ECC_BASE,UCRP_ECC_LEN,ecc_val);
#endif 							/* __UCRP_ECC_ENABLE__	*/

 u_char tab[256];
 for(pos = 0; pos < 256; ++pos) {
    tab[pos] = pos;
 }

 for(pos = 0; pos < 256 * 4; ++pos) {
    u_char ch0;
    u_char ch1;
    u_char vl0;
    u_char vl1;
    ch0 = ucrp_random();
    ch1 = ucrp_random();
    vl0 = tab[ch0];
    vl1 = tab[ch1];
    tab[ch0] = vl1;
    tab[ch1] = vl0;
 }  

 for(pos = 0; pos < 256; ++pos) {
    ucrp_key_val(UCRP_TABLE_BASE + pos * 8, 8, tab[pos]);
 }

#if defined __UCRP_XOR_ENABLE__ || defined __UCRP_XRE_ENABLE__
 {
/* defined xor or xre algorithm */
    u_char xrl;					/* xor low */
    u_char xrv;					/* xor low value */

    xrl = (ucrp_random() % (UCRP_LOW_MAX + 1));	/* random xor low */
    xrv = (ucrp_random() & 0x7);		/* random xor low value */

    ucrp_key_val(UCRP_XRL_BASE,UCRP_XRL_LEN, xrl); /* write xor low */
    ucrp_key_val(UCRP_XRV_BASE,UCRP_XRV_LEN, xrv); /* write xor value */
 }
#endif 							/* __UCRP_XOR_ENABLE__ */

#ifdef __UCRP_BTS_ENABLE__
 {
    /* fill bit table */
    u_char bttb[8];			/* bit swapping table */
    int bpos;				/* bit swapping table position */
    for(bpos = 0; bpos < 8; ++bpos) {	/* fill bit swapping table */
	bttb[bpos] = bpos;		
    }

    /* swap bit table */
    for(bpos = 0; bpos < 16; ++bpos) {
	u_char ch0;			/* table position 0 */
	u_char ch1;			/* table position 1 */
	u_char vl0;			/* readed value 0 */
	u_char vl1;			/* readed value 1 */
	ch0 = (ucrp_random() & 0x7);	/* random table position 0 */
	ch1 = (ucrp_random() & 0x7);	/* random table position 1 */
	vl0 = bttb[ch0];
	vl1 = bttb[ch1];
	bttb[ch0] = vl1;
	bttb[ch1] = vl0;
    }

    /* write bit swap table to key buffer */
    for(bpos = 0; bpos < 8; ++bpos) {
	ucrp_key_val(UCRP_BTS_BASE + bpos * 8, 8, bttb[bpos]);
    }
 }  
#endif							/* __UCRP_BTS_ENABLE__ */

/* */
 return(1);
}

/* read compatibylity buffer */
int ucrp_comp_read(void)
{
/* input file descriptor */
 if(ucrp_fi == 0) {
    return(0);
 }

 if(fread(ucrp_comp_buf, 1, sizeof(ucrp_comp_buf), ucrp_fi) != 
    sizeof(ucrp_comp_buf)) {
    return(0);
 }

/* write source buffer size to compatibility buffer */
 ucrp_src_buf_size = ucrp_comp_val(UCRP_SBL, UCRP_SBL_LEN, -1);
 if(ucrp_src_buf_size == 0) {
    ucrp_src_buf_size = UCRP_SRC_SIZE;
 }

/* write destination buffer size to compatibility buffer */
 ucrp_dst_buf_size = ucrp_comp_val(UCRP_DBL, UCRP_DBL_LEN, -1);
 if(ucrp_dst_buf_size == 0) {
    ucrp_dst_buf_size = UCRP_BUF_SIZE;
 }
 
 return(1);
}

/* read compatibylity buffer */
int ucrp_comp_write(void)
{
/* input file descriptor */
 if(ucrp_fo == 0) {
    return(0);
 }

 if(fwrite(ucrp_comp_buf, 1, sizeof(ucrp_comp_buf), ucrp_fo) != 
    sizeof(ucrp_comp_buf)) {
    return(0);
 }
 return(1);
}


/* read key buffer */
int ucrp_key_read(void)
{
/* input file descriptor */
 if(ucrp_fi == 0) {
    return(0);
 }

 if(fread(ucrp_key_buf, 1, sizeof(ucrp_key_buf), ucrp_fi) != 
    sizeof(ucrp_key_buf)) {
    return(0);
 }
 return(1);
}

int ucrp_key_write(void)
{
/* input file descriptor */
 if(ucrp_fo == 0) {
    return(0);
 }

 if(fwrite(ucrp_key_buf, 1, sizeof(ucrp_key_buf), ucrp_fo) != 
    sizeof(ucrp_key_buf)) {
    return(0);
 }
 return(1);
}

/* print file information */

int ucrp_info(void)
{
 u_char xre_comp;			/* xor */
 u_char xor_comp;			/* xor */
 u_char add_comp;			/* add */
 u_char rot_comp;			/* rot */
 u_char tab_comp;			/* tab */
 u_char ecc_comp;			/* ecc */
 u_char bts_comp;			/* bts compativility */

 u_char xor_val;			/* xor */
 u_char add_val;			/* add */
 u_char rot_val;			/* rot */
 u_char tab_val;			/* tab */
 u_char ecc_val;			/* ecc */
 u_char bts_val[8];			/* bts conversion table */

 {
/* print ucrp version */
    char cver[9];			/* ver */
    int vpos;				/* buffer position */
    for(vpos = 0; vpos < 9; ++vpos) { 	
	cver[vpos] = ucrp_comp_buf[vpos];
    }
    cver[8] = '\0';			/* string terminator */
    ucrp_printf(UMSG_INFO_VERSION, cver); /* print program version */
 }

#if defined __UCRP_XOR_ENABLE__ || defined __UCRP_XRE_ENABLE__
 if(ucrp_passwd[0] == '\0') {
    xor_comp = ucrp_comp(UCRP_XOR, -1);		/* xor compatibility */
    xre_comp = ucrp_comp(UCRP_XRE, -1);		/* xor compatibility */
    xor_val = ucrp_key_val(UCRP_XOR_BASE,UCRP_XOR_LEN,-1);
    ucrp_printf(UMSG_INFO_XOR, (xor_comp ? UMSG_INFO_ON : UMSG_INFO_OFF), xor_val);
    ucrp_printf(UMSG_INFO_XRE, (xre_comp ? UMSG_INFO_ON : UMSG_INFO_OFF), xor_val);
    {
	u_char xrl;				/* xor low */
	u_char xrv;				/* xor low value */
        char * sxrv;			/* xor low string */

	/* read low numeric value */
	xrl = ucrp_key_val(UCRP_XRL_BASE, UCRP_XRL_LEN, -1);
	/* read low value */
	xrv = ucrp_key_val(UCRP_XRV_BASE, UCRP_XRV_LEN, -1);

	switch(xrl) {
	 case UCRP_LOW_NULL : sxrv = UMSG_LOW_NULL; break;	/* null low */
	 case UCRP_LOW_AD3	: sxrv = UMSG_LOW_AD3; break;	/* add low */
	 case UCRP_LOW_ROT	: sxrv = UMSG_LOW_ROT; break;	/* rot low */
	 case UCRP_LOW_TAB	: sxrv = UMSG_LOW_TAB; break;	/* tab low */
	 case UCRP_LOW_BTS	: sxrv = UMSG_LOW_BTS; break;	/* bts low */
         default : 
    	    sxrv = UMSG_LOW_UNKN;
    	    break;
	}

	ucrp_printf(UMSG_INFO_XRL, sxrv, xrl);	/* print xor low name */
	ucrp_printf(UMSG_INFO_XRV, xrv);		/* print xor low value */	
    }
 } else {
    xor_comp = ucrp_comp(UCRP_XOR, -1);		/* xor compatibility */
    ucrp_printf("xor %s %d\n", (xor_comp ? UMSG_INFO_ON : UMSG_INFO_OFF));
    if(xor_comp != 0) {
        char * sxrv;			/* xor low string */
	u_char xrl;				/* xor low */
	u_char xrv;				/* xor low value */
	xor_val = ucrp_key_val(UCRP_XOR_BASE, UCRP_XOR_LEN, -1) + ucrp_passwd[0];
	/* read low numeric value */
	xrl = ucrp_key_val(UCRP_XRL_BASE, UCRP_XRL_LEN, -1);
	/* read low value */
	xrv = ucrp_key_val(UCRP_XRV_BASE, UCRP_XRV_LEN, -1);
 /* */
        if(xrl != UCRP_LOW_NULL) {
	    xrl += (ucrp_passwd[0] >> 3);	/* modify xor low with passwd */
	    xrl =  (xrl % (UCRP_LOW_MAX + 1));	/* correct modified value */

	    if(xrv == UCRP_LOW_AD3) {		/* add low */
		xrv = (xrv + ucrp_passwd[0]);	/* xor add value */
		sxrv = UMSG_LOW_AD3;
	    } else 
	    if(xrv == UCRP_LOW_ROT) {		/* rot low */
		xrv = ((xrv + ucrp_passwd[0]) & 0x7);	/* rotate value */
		sxrv = UMSG_LOW_ROT;
	    } else 
	    if(xrv == UCRP_LOW_TAB) {		/* tab low */
		xrv = (xrv + ucrp_passwd[0]);	/* modify xor low value */
		sxrv = UMSG_LOW_TAB;
	    } else 
	    if(xrv == UCRP_LOW_BTS) {		/* bts low */
		xrv = ((xrv + ucrp_passwd[0]) & 0x7);	/* modify xor low value */
		sxrv = UMSG_LOW_BTS;
	    } else {
    		sxrv = UMSG_LOW_UNKN;		/* unknown low */
	    }
	} else {
	    sxrv = UMSG_LOW_NULL;
	}
	ucrp_printf(UMSG_INFO_XRL, sxrv, xrl);	/* print xor low name */
	ucrp_printf(UMSG_INFO_XRV, xrv);	/* print xor low value */	
    }

    xre_comp = ucrp_comp(UCRP_XRE, -1);		/* xor compatibility */
    if(xre_comp != 0) {
        char * sxrv;			/* xor low string */
	u_char xrl;				/* xor low */
	u_char xrv;				/* xor low value */
	xor_val = ucrp_key_val(UCRP_XOR_BASE, UCRP_XOR_LEN, -1) + ucrp_passwd[0];
	/* read low numeric value */
	xrl = ucrp_key_val(UCRP_XRL_BASE, UCRP_XRL_LEN, -1);
	/* read low value */
	xrv = ucrp_key_val(UCRP_XRV_BASE, UCRP_XRV_LEN, -1);

	xrl += (ucrp_passwd[0] >> 3);		/* modify xor low with passwd */
	xrl = (xrl % (UCRP_LOW_MAX + 1));	/* correct modified value */
	xrv = ((xrv + ucrp_passwd[0]) & 0x7);	/* rotate value */
/* */
	if(xrl != UCRP_LOW_NULL) {
	    if(xrl == UCRP_LOW_AD3) {		/* add low */
		sxrv = UMSG_LOW_AD3;
	    } else 
	    if(xrl == UCRP_LOW_ROT) {		/* rot low */
		sxrv = UMSG_LOW_ROT;
	    } else 
	    if(xrl == UCRP_LOW_TAB) {		/* tab low */
		sxrv = UMSG_LOW_TAB;
	    } else 
	    if(xrl == UCRP_LOW_BTS) {		/* bts low */
		sxrv = UMSG_LOW_BTS;
	    } else {
    		sxrv = UMSG_LOW_UNKN;		/* unknown low */
	    }
	} else {
	    sxrv = UMSG_LOW_NULL;
	}
	ucrp_printf(UMSG_INFO_XRE, (xre_comp ? UMSG_INFO_ON : UMSG_INFO_OFF), xor_val);
	ucrp_printf(UMSG_INFO_XRL, sxrv, xrl);	/* print xor low name */
	ucrp_printf(UMSG_INFO_XRV, xrv);	/* print xor low value */	
    }
 }
#endif /* defined __UCRP_XOR_ENABLE__ || defined __UCRP_XRE_ENABLE__ */

#ifdef __UCRP_ADD_ENABLE__
    add_comp = ucrp_comp(UCRP_ADD, -1);		/* add compatibility */
 if(ucrp_passwd[0] == '\0') {
    add_val = ucrp_key_val(UCRP_ADD_BASE,UCRP_ADD_LEN,-1);
 } else {
    add_val = ucrp_key_val(UCRP_ADD_BASE,UCRP_ADD_LEN,-1) + ucrp_passwd[1];
 }
 ucrp_printf(UMSG_INFO_ADD, (add_comp ? UMSG_INFO_ON : UMSG_INFO_OFF), add_val);
#endif 						/* __UCRP_ADD_ENABLE__ */


#ifdef __UCRP_ROT_ENABLE__
 rot_comp = ucrp_comp(UCRP_ROT, -1);		/* byte rotate */
 if(ucrp_passwd[0] == '\0') {
    rot_val = ucrp_key_val(UCRP_ROT_BASE,UCRP_ROT_LEN,-1);
 } else {
    rot_val = (ucrp_key_val(UCRP_ROT_BASE,UCRP_ROT_LEN,-1) + ucrp_passwd[2]) & 0x7;
 }
 ucrp_printf(UMSG_INFO_ROT, (rot_comp ? UMSG_INFO_ON : UMSG_INFO_OFF), rot_val);
#endif 						/* __UCRP_ROT_ENABLE__ */

#ifdef __UCRP_TAB_ENABLE__
 tab_comp = ucrp_comp(UCRP_TAB, -1);		/* byte table */
 tab_val = ucrp_key_val(UCRP_TAB_BASE,UCRP_TAB_LEN,-1);
 ucrp_printf(UMSG_INFO_TAB, (tab_comp ? UMSG_INFO_ON : UMSG_INFO_OFF), tab_val);

 {
    u_char ttab[256];				/* translate table */
    int tpos;					/* translate positiom */
    for(tpos = 0; tpos < 256; ++tpos) {	
    /* read translate table */
	ttab[tpos] = ucrp_key_val(UCRP_TABLE_BASE + (tpos * 8), 8, -1);
    }

    ucrp_printf(UMSG_INFO_TRT);

    for(tpos = 0; tpos < 256; ++tpos) {	
    /* print translate table value */
    	ucrp_printf(UMSG_02X, ttab[tpos]);	/* translate table value */	
    	ucrp_printf(UMSG_SP);			/* translate table value */	

	if(((tpos + 1) & 0xF) == 0) {	
    	    ucrp_printf(UMSG_CRNL);		/* print table separator */
	}
    }
 }
#endif 						/* __UCRP_TAB_ENABLE__ */

#ifdef __UCRP_ECC_ENABLE__
 ecc_comp = ucrp_comp(UCRP_ECC, -1);		/* ecc coding */	
 ecc_val = ucrp_key_val(UCRP_ECC_BASE,UCRP_ECC_LEN,-1);
 ucrp_printf(UMSG_INFO_ECC, (ecc_comp ? UMSG_INFO_ON : UMSG_INFO_OFF), ecc_val);
#endif 						/* __UCRP_ECC_ENABLE__ */

#ifdef __UCRP_BTS_ENABLE__
 /* read bts compatibility */
 bts_comp = ucrp_comp(UCRP_BTS, -1);		
 {
    ucrp_printf(UMSG_INFO_BTS, (bts_comp ? UMSG_INFO_ON : UMSG_INFO_OFF));
    /* write bit swap table to key buffer */
    int bpos;				/* bts table position */
    for(bpos = 0; bpos < 8; ++bpos) {	/* read bts value */
	bts_val[bpos] = 
	    ucrp_key_val(UCRP_BTS_BASE + bpos * 8, 8, -1);
    }

    for(bpos = 0; bpos < 8; ++bpos) {	/* read bts value */
	ucrp_printf(UMSG_02X, bts_val[bpos]);
	ucrp_printf(UMSG_SP);
    }
    ucrp_printf(UMSG_CRNL);		/* print table separator */
 }
#endif 						/* __UCRP_BTS_ENABLE__ */

/* source buffer size */
 int ssize;
 ssize = ucrp_comp_val(UCRP_SBL, UCRP_SBL_LEN, -1);
 ucrp_printf(UMSG_INFO_SBL, ssize, ssize);


/* destination buffer size */
 int dsize;
 dsize = ucrp_comp_val(UCRP_DBL, UCRP_DBL_LEN, -1);
 ucrp_printf(UMSG_INFO_DBL, dsize, dsize);

/* */
 return(1);
}


/* passwd hash init*/
int ucrp_hash_init(void)
{
 int pos;
 if(ucrp_passwd[0] == '\0') {
/* empty passwd */
    for(pos = 0; pos < (int) sizeof(ucrp_passwd); ++pos) {
	ucrp_passwd[pos] = pos;
    }
 } else {
/* not empty passwd */
    int len;				/* passwd length */
    len = strlen(ucrp_passwd);		/* read passwd length */ 
    pos = len;				/* to passwd end */
    while(pos < (int)sizeof(ucrp_passwd)) {
	int ps;
	ps = 0;
	while(ps < len) {
	    if(pos >= (int)sizeof(ucrp_passwd)) {
		break;
	    }

	    ucrp_passwd[pos] = ucrp_passwd[ps];
	    ps += 1;
	    pos += 1;
	}
    }
 }

 u_char xor0_comp;			/* xor basic compatibility */
 u_char xor1_comp;			/* xor extended compatibility */
 u_char xor_comp;			/* xor compatibility */
 u_char add_comp;			/* add compatibility */
 u_char rot_comp;			/* rot compatibility */
 u_char tab_comp;			/* tab compatibility */
 u_char ecc_comp;			/* ecc compatibility */

 u_char xor_val;			/* xor value */
 u_char add_val;			/* add value */
 u_char rot_val;			/* rot value */
 u_char tab_val;			/* tab value */
 u_char ecc_val;			/* ecc value */

 xor0_comp =
#if defined __UCRP_XOR_ENABLE__
    ucrp_comp(UCRP_XOR, -1);				/* xor compatibility */
#else 
    0;
#endif 							/* __UCRP_XOR_ENABLE__ */

 xor1_comp =
#if defined __UCRP_XRE_ENABLE__
    ucrp_comp(UCRP_XRE, -1);				/* xre compatibility */
#else 
    0;
#endif 							/* __UCRP_XOR_ENABLE__ */

 if((xor0_comp == 1) || (xor1_comp == 1)) {
/* defined xor basic or xor extended algorithm */
    xor_comp = 1;
 } else {
    xor_comp = 0;			/* disable any xor algorithm */
 }

 add_comp = 
#ifdef __UCRP_ADD_ENABLE__
    ucrp_comp(UCRP_ADD, -1);				/* add compatibility */
#else 
    0;
#endif 							/* __UCRP_ADD_ENABLE__ */

 rot_comp = 
#ifdef __UCRP_ROT_ENABLE__
    ucrp_comp(UCRP_ROT, -1);				/* byte rotate */
#else 
    0;
#endif 							/* __UCRP_ROT_ENABLE__ */

 tab_comp = 
#ifdef __UCRP_TAB_ENABLE__
    ucrp_comp(UCRP_TAB, -1);				/* byte table */
#else 
    0;
#endif 							/* __UCRP_TAB_ENABLE__ */

 ecc_comp = 
#ifdef __UCRP_ECC_ENABLE__
    ucrp_comp(UCRP_ECC, -1);				/* ecc coding */	
#else 
    0;
#endif 							/* __UCRP_ECC_ENABLE__ */

 xor_val = ucrp_key_val(UCRP_XOR_BASE,UCRP_XOR_LEN,-1);
 add_val = ucrp_key_val(UCRP_ADD_BASE,UCRP_ADD_LEN,-1);
 rot_val = ucrp_key_val(UCRP_ROT_BASE,UCRP_ROT_LEN,-1);
 tab_val = ucrp_key_val(UCRP_TAB_BASE,UCRP_TAB_LEN,-1);
 ecc_val = ucrp_key_val(UCRP_ECC_BASE,UCRP_ECC_LEN,-1);

 if(xor_comp) {
/* xor compatibility */
    for(pos = 0; pos < (int)sizeof(ucrp_passwd); ++pos) {
	u_char ch;
	ch = ucrp_passwd[pos];
	ch = (ch ^ xor_val);
	ucrp_passwd[pos] = ch;
    }
 }
 
 if(add_comp) {
/* add compatibility */
    for(pos = 0; pos < (int)sizeof(ucrp_passwd); ++pos) {
	u_char ch;
	ch = ucrp_passwd[pos];
	ch = (ch + add_val);
	ucrp_passwd[pos] = ch;
    }
 }

 if(rot_comp) {
/* rot compatibility */
    for(pos = 0; pos < (int)sizeof(ucrp_passwd); ++pos) {
	u_char ch;
	ch = ucrp_passwd[pos];
	ch = ((ch >> rot_val) | (ch << (8 - rot_val)));
	ucrp_passwd[pos] = ch;
    }
 }

 if(tab_comp) {
    u_char tab[256];
    for(pos = 0; pos < 256; ++pos) {
	tab[pos] = pos;
    }

    if(xor_comp) {
	for(pos = 0; pos < 256; ++pos) {
	    u_char ch;
	    ch = tab[pos];
	    ch = (ch ^ xor_val);
	    tab[pos] = ch;
	}
    }

    if(add_comp) {
	for(pos = 0; pos < 256; ++pos) {
	    u_char ch;
	    ch = tab[pos];
	    ch = (ch + add_val);
	    tab[pos] = ch;
	}
    }

    if(rot_comp) {
	for(pos = 0; pos < 256; ++pos) {
	    u_char ch;
	    ch = tab[pos];
	    ch = ((ch >> rot_val) | (ch << (8 - rot_val)));
	    tab[pos] = ch;
	}
    }

    for(pos = 0; pos < (int)sizeof(ucrp_passwd); ++pos) {
	u_char ch;
	ch = ucrp_passwd[pos];
	ch = tab[ch];
	ucrp_passwd[pos] = ch;
    }
 }

#ifdef __UCRP_HASH_DEBUG__
 ucrp_printf(UMSG_CRLF);
 ucrp_printf(UMSG_HASH);
 for(pos = 0; pos < (int)sizeof(ucrp_passwd); ++pos) {
    ucrp_printf(UMSG_02X, ucrp_passwd[pos]);
    ucrp_printf(UMSG_SP);
 }
 ucrp_printf(UMSG_CRLF);
#endif 							/* __UCRP_HASH_DEBUG__ */

 return(1);
}

/* read buffer from input file */
int ucrp_read(u_char * src, int cnt)
{
 if(ucrp_fi == 0) {
    return(0);
 }

 cnt = fread(src, 1, cnt, ucrp_fi);
 return(cnt);
}

int ucrp_write(u_char * src, int cnt)
{
 if(ucrp_fi == 0) {
    return(0);
 }

 cnt = fwrite(src, 1, cnt, ucrp_fo);
 return(cnt);
}

#ifdef __UCRP_XOR_ENABLE__


/* xor encrypt */
int ucrp_xor_en(u_char * dst, u_char * src, int len)
{
 u_char xor_val;			/* xor mask */
 u_char xrl;				/* xor mask change low */
 u_char xrv;				/* xor mask change low value */
 int rvl; 				/* return value */

/* */
 rvl = 1;				/* start return value */

 xor_val = ucrp_key_val(UCRP_XOR_BASE, UCRP_XOR_LEN, -1) + ucrp_passwd[0];
 /* read low numeric value */
 xrl = ucrp_key_val(UCRP_XRL_BASE, UCRP_XRL_LEN, -1);
 /* read low value */
 xrv = ucrp_key_val(UCRP_XRV_BASE, UCRP_XRV_LEN, -1);

 /* */
 if(xrl != UCRP_LOW_NULL) {
    xrl += (ucrp_passwd[0] >> 3);	/* modify xor low with passwd */
    xrl =  (xrl % (UCRP_LOW_MAX + 1));	/* correct modified value */

    if(xrv == UCRP_LOW_AD3) {		/* add low */

	xrv = (xrv + ucrp_passwd[0]);	/* xor add value */
	int pos;
	for(pos = 0; pos < len; ++pos) {
	    /* encryp/decrypt byte */
	    *(dst + pos) = (*(src + pos) ^ xor_val);	
	    xor_val += xrv;		/* modify xor mask */
	}
    } else 
    if(xrv == UCRP_LOW_ROT) {		/* rot low */

	xrv = ((xrv + ucrp_passwd[0]) & 0x7);	/* rotate value */
	int pos;
	for(pos = 0; pos < len; ++pos) {
	    /* encrypt/decrypt byte */
	    *(dst + pos) = (*(src + pos) ^ xor_val);
	    /* rotate xor mask */
	    xor_val = (xor_val >> xrv) | (xor_val << (8 - xrv));
	}
    } else 
    if(xrv == UCRP_LOW_TAB) {		/* tab low */

	/* read primary table */
	u_char ttab[256];		/* mask change table */
	int spos;			/* source buffer position */
	int dpos;			/* destination buffer position */
	/* */
	xrv = (xrv + ucrp_passwd[0]);	/* modify xor low value */
	dpos = (xrv & 0xFF);		/* correct xor low value */
	/* read mask translate table */
	for(spos = 0; spos < 256; ++spos) {	
	    ttab[spos] = ucrp_key_val(UCRP_TABLE_BASE + (dpos * 8), 8, -1);
	    dpos += 1;			/* next position in destination table */
	    if(dpos >= 256) {		/* set destination position to start of tranlate table */
		dpos = 0;
	    }
	}

	int pos;			
	for(pos = 0; pos < len; ++pos) {
	    /* encrypt/decryp byte */
	    *(dst + pos) = (*(src + pos) ^ xor_val);
	    /* modify xor mask */
	    xor_val = ttab[ (xor_val & 0xFF) ];
	}
    } else 
    if(xrv == UCRP_LOW_BTS) {		/* bts low */

	u_char bttb[8];			/* write to bit swapping table */
	int dpos;			/* next key read position */
	int bpos;			/* bit table position */
	int tval;			/* test value */

	/* modify xor low value */
	xrv = ((xrv + ucrp_passwd[0]) & 0x7);
	dpos = xrv;			/* destination position */
	if((dpos < 0) || (dpos >= 8)) {	/* set destination position */
	    dpos = 0;			/* to buffer start */
	}
	tval = 0;			/* test value */
 /* */
	for(bpos = 0; bpos < 8; ++bpos) {
	    u_int8_t chky;		/* readed byte from bit swapping table */
	    /* read from table */
	    chky = ucrp_key_val(UCRP_BTS_BASE + dpos * 8, 8, -1);
	    if(chky >= 8) {		/* not correct bit number */
	    	chky = 0;		/* 0 - 7 */	
		rvl = 0;		/* clear return value */
	    }

	    if((tval & (1 << chky)) > 0) {	
	    /* internal error -> clear return value */	
		rvl = 0;
	    } else {
		tval |= (1 << chky);		/* set bit */
	    }

	    bttb[dpos] = chky;		/* write to bit swapping table */
	    dpos = ((dpos + 1) & 0x7);	/* next key read position */
	}

	if(rvl == 0) {
	    ucrp_error(UMSG_XOR_ERR);
	}


	u_char ttab[256];			/* translate table */
	int tpos;				/* translate table position */
	
	for(tpos = 0; tpos < 256; ++tpos) {	
	    u_int8_t tval = tpos;		/* translate table index */
	    u_int8_t tres = 0;			/* translate value */

	    for(bpos = 0; bpos < 8; ++bpos) {		
		if( (tval & (1 << bttb[bpos])) ) {  /* if bit seted in inde */
		    tres |= (1 << bpos);	    /* set bit in translated value  */
		}
	    }

	    *(ttab + tpos) = tres;		/* write to result value */
	}

	int pos;
	for(pos = 0; pos < len; ++pos) {
	    /* encrypt/decrypt byte */
	    *(dst + pos) = (*(src + pos) ^ xor_val);
	    /* modify xor mask */
	    xor_val = ttab[ xor_val ];
	}
    } else {
    /* unknown low */

	int pos;
	for(pos = 0; pos < len; ++pos) {
	    /* encrypt/decrypt byte */
	    *(dst + pos) = (*(src + pos) ^ xor_val);
	}
    }
 } else {
/* UCRP_LOW_NULL - xor with constant mask */

    int pos;				/* buffer position */
    for(pos = 0; pos < len; ++pos) {	
	*(dst + pos) = (*(src + pos) ^ xor_val);	/* encrypt byte */
    }
 }

 return(len);				/* bytes encrypted/decrypted */
}
#endif						/* __UCRP_XOR_ENABLE__ */

#ifdef __UCRP_XRE_ENABLE__
/* xor with extended compatibility */


/* xor encrypt */
int ucrp_xre_en(u_char * dst, u_char * src, int len)
{
 u_char xor_val;			/* xor mask */
 u_char xrl;				/* xor mask change low */
 u_char xrv;				/* xor mask change low value */
 int rvl; 				/* return value */

/* */
 rvl = 1;				/* start return value */

 xor_val = ucrp_key_val(UCRP_XOR_BASE, UCRP_XOR_LEN, -1) + ucrp_passwd[0];
 /* read low numeric value */
 xrl = ucrp_key_val(UCRP_XRL_BASE, UCRP_XRL_LEN, -1);
 /* read low value */
 xrv = ucrp_key_val(UCRP_XRV_BASE, UCRP_XRV_LEN, -1);

 xrl += (ucrp_passwd[0] >> 3);		/* modify xor low with passwd */
 xrl = (xrl % (UCRP_LOW_MAX + 1));	/* correct modified value */
 xrv = ((xrv + ucrp_passwd[0]) & 0x7);	/* rotate value */

/* */
 if(xrl != UCRP_LOW_NULL) {

    if(xrl == UCRP_LOW_AD3) {		/* add low */
	int pos;
	for(pos = 0; pos < len; ++pos) {
	    /* encryp/decrypt byte */
	    *(dst + pos) = (*(src + pos) ^ xor_val);	
	    xor_val += xrv;		/* modify xor mask */
	}
    } else 
    if(xrl == UCRP_LOW_ROT) {		/* rot low */
	int pos;
	for(pos = 0; pos < len; ++pos) {
	    /* encrypt/decrypt byte */
	    *(dst + pos) = (*(src + pos) ^ xor_val);
	    /* rotate xor mask */
	    xor_val = (xor_val >> xrv) | (xor_val << (8 - xrv));
	}
    } else 
    if(xrl == UCRP_LOW_TAB) {		/* tab low */

	/* read primary table */
	u_char ttab[256];		/* mask change table */
	int spos;			/* source buffer position */
	int dpos;			/* destination buffer position */
	/* */
	dpos = (xrv & 0xFF);		/* correct xor low value */
	/* read mask translate table */
	for(spos = 0; spos < 256; ++spos) {	
	    ttab[spos] = ucrp_key_val(UCRP_TABLE_BASE + (dpos * 8), 8, -1);
	    dpos += 1;			/* next position in destination table */
	    if(dpos >= 256) {		/* set destination position to start of tranlate table */
		dpos = 0;
	    }
	}

	int pos;			
	for(pos = 0; pos < len; ++pos) {
	    /* encrypt/decryp byte */
	    *(dst + pos) = (*(src + pos) ^ xor_val);
	    /* modify xor mask */
	    xor_val = ttab[ (xor_val & 0xFF) ];
	}
    } else 
    if(xrl == UCRP_LOW_BTS) {		/* bts low */

	u_char bttb[8];			/* write to bit swapping table */
	int dpos;			/* next key read position */
	int bpos;			/* bit table position */
	int tval;			/* test value */

	/* modify xor low value */
	dpos = xrv;			/* destination position */
	if((dpos < 0) || (dpos >= 8)) {	/* set destination position */
	    dpos = 0;			/* to buffer start */
	}
	tval = 0;			/* test value */
 /* */
	for(bpos = 0; bpos < 8; ++bpos) {
	    u_int8_t chky;		/* readed byte from bit swapping table */
	    /* read from table */
	    chky = ucrp_key_val(UCRP_BTS_BASE + dpos * 8, 8, -1);
	    if(chky >= 8) {		/* not correct bit number */
	    	chky = 0;		/* 0 - 7 */	
		rvl = 0;		/* clear return value */
	    }

	    if((tval & (1 << chky)) > 0) {	
	    /* internal error -> clear return value */	
		rvl = 0;
	    } else {
		tval |= (1 << chky);		/* set bit */
	    }

	    bttb[dpos] = chky;		/* write to bit swapping table */
	    dpos = ((dpos + 1) & 0x7);	/* next key read position */
	}

	if(rvl == 0) {
	    ucrp_error(UMSG_XOR_ERR);
	}

	u_char ttab[256];			/* translate table */
	int tpos;				/* translate table position */
	
	for(tpos = 0; tpos < 256; ++tpos) {	
	    u_int8_t tval = tpos;		/* translate table index */
	    u_int8_t tres = 0;			/* translate value */

	    for(bpos = 0; bpos < 8; ++bpos) {		
		if( (tval & (1 << bttb[bpos])) ) {  /* if bit seted in inde */
		    tres |= (1 << bpos);	    /* set bit in translated value  */
		}
	    }

	    *(ttab + tpos) = tres;		/* write to result value */
	}
	int pos;
	for(pos = 0; pos < len; ++pos) {
	    /* encrypt/decrypt byte */
	    *(dst + pos) = (*(src + pos) ^ xor_val);
	    /* modify xor mask */
	    xor_val = ttab[ xor_val ];
	}
    } else {
    /* unknown low */

	int pos;
	for(pos = 0; pos < len; ++pos) {
	    /* encrypt/decrypt byte */
	    *(dst + pos) = (*(src + pos) ^ xor_val);
	}
    }
 } else {
/* UCRP_LOW_NULL - xor with constant mask */

    int pos;				/* buffer position */
    for(pos = 0; pos < len; ++pos) {	
	*(dst + pos) = (*(src + pos) ^ xor_val);	/* encrypt byte */
    }
 }

 return(len);				/* bytes encrypted/decrypted */
}
#endif						/* __UCRP_XRE_ENABLE__ */


#ifdef __UCRP_ADD_ENABLE__
/* add encrypt */
int ucrp_add_en(u_char * dst, u_char * src, int len)
{
 u_char add_val;
 int pos;
/* */
 add_val = ucrp_key_val(UCRP_ADD_BASE,UCRP_ADD_LEN,-1) + ucrp_passwd[1];

 for(pos = 0; pos < len; ++pos) {
    u_char ch;
    ch = *(src + pos);
    ch = ch + add_val;
    *(dst + pos) = ch;
    add_val += 1;
 }
 return(len);
}
#endif 						/* __UCRP_ADD_ENABLE__ */


#ifdef __UCRP_ADD_ENABLE__
/* add decrypt */
int ucrp_add_de(u_char * dst, u_char * src, int len)
{
 u_char add_val;
 int pos;
/* */
 add_val = ucrp_key_val(UCRP_ADD_BASE,UCRP_ADD_LEN,-1) + ucrp_passwd[1];

 for(pos = 0; pos < len; ++pos) {
    u_char ch;
    ch = *(src + pos);
    ch = (256 + ch) - add_val;
    *(dst + pos) = ch;
    add_val += 1;
 }
 return(len);
}
#endif 						/* __UCRP_ADD_ENABLE__ */

/* init bit swapping translate table */

int ucrp_bts_init(u_int8_t * ttab, int en)
{
 u_int8_t bttb[8];			/* bit swapping table */
 u_int8_t tval;				/* bit swapping check table */
 int bpos;				/* bit swapping tavle position  */
 int kpos;				/* key buffer position */

/* test value */
 tval = 0;

 kpos = (ucrp_passwd[3] & 0x7);		/* table position */
 for(bpos = 0; bpos < 8; ++bpos) {	/* read bit swapping table */
    u_int8_t chky;
    /* read from table */
    chky = ucrp_key_val(UCRP_BTS_BASE + kpos * 8, 8, -1);

    if(chky >= 8) {			/* not correct value for bit number */
	return(0);
    }

    if((tval & (1 << chky)) > 0) {	
	return(0);
    } else {
	tval |= (1 << chky);		/* set bit */
    }

    bttb[kpos] = chky;			/* write to bit swapping table */
    kpos = ((kpos + 1) & 0x7);		/* next key read position */
 }

/* */
 int tpos;				/* translate table position */
 for(tpos = 0; tpos < 256; ++tpos) {	
    u_int8_t tval = tpos;		/* translate table index */
    u_int8_t tres = 0;			/* translate value */

    for(bpos = 0; bpos < 8; ++bpos) {		
	if( (tval & (1 << bttb[bpos])) ) {	/* if bit seted in inde */
	    tres |= (1 << bpos);		/* set bit in translated value  */
	}
    }

    *(ttab + tpos) = tres;		/* write to result value */
 }

#if 0
 ucrp_printf(UMSG_CRLF);
 ucrp_printf(UMSG_BTTB);
 for(tpos = 0; tpos < 8; ++tpos) {
    ucrp_printf(UMSG_02X, (u_char) bttb[tpos]);
    ucrp_printf(UMSG_SP);
 }

 ucrp_printf(UMSG_CRLF);
 for(tpos = 0; tpos < 256; ++tpos) {
    ucrp_printf(UMSG_02X, (u_char) *(ttab + tpos));
    ucrp_printf(UMSG_SP);
 }
#endif 							/* 1 */



 if(en == 1) {
    return(1);
 }

 u_int8_t rtab[256];			/* reverse table */
 for(tpos = 0; tpos < 256; ++tpos) {	/* buffer position */
    u_int8_t chtb;			/* readed character */
    chtb = (ttab[tpos] & 0xFF);		/* read character from translate table */
    rtab[chtb] = tpos;			/* write reverced value */
 }

 for(tpos = 0; tpos < 256; ++tpos) {
    *(ttab + tpos) = rtab[tpos];
 }

#if 0
 ucrp_printf(UMSG_CRLF);
 ucrp_printf(UMSG_RTAB);
 for(tpos = 0; tpos < 256; ++tpos) {
    ucrp_printf(UMSG_02X, (u_char) *(ttab + tpos));
    ucrp_printf(UMSG_SP);
 }
#endif 							/* 1 */

 return(1);
}

/* bit swapping coding */

int ucrp_bts_en(u_char * dst, u_char * src, int len)
{
/* check source and destination pointer */
 if((dst == 0) || (src == 0)) {
    return(0);
 }

/* */
 u_int8_t ttab[256];			/* translate table */
 if(ucrp_bts_init(ttab, 1) < 0) {	/* init translate table */
    return(0);
 }

 int bpos;				/* buffer position */
 for(bpos = 0; bpos < len; ++bpos) {	
    u_int8_t chtb;			/* readed character */
    chtb = *(src + bpos);		/* read character from source buffer */
    chtb = ttab[(chtb & 0xFF)];		/* translate character */
    *(dst + bpos) = chtb;		/* write character to destination buffer */
 }

/* */
 return(len);
}

/* bit swapping decoding */

int ucrp_bts_de(u_char * dst, u_char * src, int len)
{
/* check source and destination pointer */
 if((dst == 0) || (src == 0)) {
    return(0);
 }

 u_int8_t ttab[256];			/* translate table */
 if(ucrp_bts_init(ttab, 0) < 0) {	/* init translate table */
    return(0);
 }

 int bpos;				/* buffer position */
 for(bpos = 0; bpos < len; ++bpos) {
    u_int8_t chtb;			/* read character */
    chtb = *(src + bpos);		/* read character from source buffer */
    chtb = ttab[(chtb & 0xFF)];		/* translate character */
    *(dst + bpos) = chtb;		/* write character to destination buffer */
 }

/* */
 return(len);
}


#ifdef __UCRP_ROT_ENABLE__
int ucrp_rot_en(u_char * dst, u_char * src, int len)
{
 u_char rot_val;
 int pos;
/* */
 rot_val = (ucrp_key_val(UCRP_ROT_BASE,UCRP_ROT_LEN,-1) + ucrp_passwd[2]) & 0x7;

 for(pos = 0; pos < len; ++pos) {
    u_char ch;
    ch = *(src + pos);
    ch = ((ch >> rot_val) | (ch << (8 - rot_val)));
    *(dst + pos) = ch;
 }

 return(len);
}
#endif 						/* __UCRP_ROT_ENABLE__ */

#ifdef __UCRP_ROT_ENABLE__
int ucrp_rot_de(u_char * dst, u_char * src, int len)
{
 u_char rot_val;
 int pos;
/* */
 rot_val = (ucrp_key_val(UCRP_ROT_BASE,UCRP_ROT_LEN,-1) + ucrp_passwd[2]) & 0x7;

 for(pos = 0; pos < len; ++pos) {
    u_char ch;
    ch = *(src + pos);
    ch = ((ch << rot_val) | (ch >> (8 - rot_val)));
    *(dst + pos) = ch;
 }

 return(len);
}
#endif 						/* __UCRP_ROT_ENABLE__ */


#ifdef __UCRP_TAB_ENABLE__

/* table encrypt */
int ucrp_tab_en(u_char * dst, u_char * src, int len)
{
/* read primary table */
 u_char tab[256];
 int pos;
/* */
 for(pos = 0; pos < 256; ++pos) {
    tab[pos] = ucrp_key_val(UCRP_TABLE_BASE + pos * 8, 8, -1);
 }

/* */
 u_char xor_val;		/* xor value */
 u_char add_val;		/* add value */
 u_char rot_val;		/* rotate value */

/* read xor,add, rot values */
 xor_val  = ucrp_key_val(UCRP_XOR_BASE,UCRP_XOR_LEN,-1);
 add_val  = ucrp_key_val(UCRP_ADD_BASE,UCRP_ADD_LEN,-1);
 rot_val  = (ucrp_key_val(UCRP_ROT_BASE,UCRP_ROT_LEN,-1) & 7);

/* copy to destination buffer*/
 for(pos = 0; pos < len; ++pos) {
    *(dst + pos) = *(src + pos);
 }

/* */ 
/* int hlen = 2; */
 int hlen = 64;
 int hnum;
/* */ 
 for(hnum = 0; hnum < hlen; ++hnum) {
    u_char hch;    

#ifdef __UCRP_TAB_DEBUG__
    {
	ucrp_printf(UMSG_TAB_EN, hnum);
        int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    ucrp_printf(UMSG_SP);
	    ucrp_printf(UMSG_02X, tab[tpos]);
	}	
	ucrp_printf(UMSG_CRNL);
    }
#endif 						/* __UCRP_TAB_DEBUG__ */

 
    for(pos = 0; pos < len; ++pos) {
	u_char ch;
	ch = *(dst + pos);
	ch = tab[ch];
	*(dst + pos) = ch;
    }

    hch = ucrp_passwd[hnum];

    if((hch & 1) != 0) {
	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    tab[tpos] = (tab[tpos] ^ xor_val);
	}
    }

    if((hch & 2) != 0) {
	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    tab[tpos] = tab[tpos] + add_val;
	}
    }

    if((hch & 4) != 0) {
	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    tab[tpos] = (tab[tpos] >> rot_val) | (tab[tpos] << (8 - rot_val));
	}
    }

#ifdef __UCRP_TAB_DEBUG__
    {
	ucrp_printf(UMSG_TAB_EN, hnum);
	int tpos;
        for(tpos = 0; tpos < 256; ++tpos) {
	    ucrp_printf(UMSG_SP);
	    ucrp_printf(UMSG_02X, tab[tpos]);
	}	
	ucrp_printf(UMSG_CRNL);
    }
#endif 						/* __UCRP_TAB_DEBUG__ */
    for(pos = 0; pos < len; ++pos) {
	u_char ch;
	ch = *(dst + pos);
	ch = tab[ch];
	*(dst + pos) = ch;
    }

    hch >>= 4;

    if((hch & 1) != 0) {
	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    tab[tpos] = (tab[tpos] ^ xor_val);
	}
    }

    if((hch & 2) != 0) {
	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    tab[tpos] = tab[tpos] + add_val;
	}
    }

    if((hch & 4) != 0) {
	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    tab[tpos] = (tab[tpos] >> rot_val) | (tab[tpos] << (8 - rot_val));
	}
    }
 }

#ifdef __UCRP_TAB_DEBUG__
    {
	ucrp_printf(UMSG_TAB_EN_END);

	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    ucrp_printf(UMSG_SP);
	    ucrp_printf(UMSG_02X, tab[tpos]);
	}	
	ucrp_printf(UMSG_CRNL);
    }
#endif 						/* __UCRP_TAB_DEBUG__ */

 return(len);
}
#endif 							/* __UCRP_TAB_ENABLE__ */

#ifdef __UCRP_TAB_ENABLE__
/* table decrypt */
int ucrp_tab_de(u_char * dst, u_char * src, int len)
{
/* read primary table */
 u_char tab[256];
 int pos;
/* */
 for(pos = 0; pos < 256; ++pos) {
    tab[pos] = ucrp_key_val(UCRP_TABLE_BASE + pos * 8, 8, -1);
 }

/* read xor, add, rot values */
 u_char xor_val;
 u_char add_val;
 u_char rot_val;

 xor_val = ucrp_key_val(UCRP_XOR_BASE,UCRP_XOR_LEN,-1);
 add_val = ucrp_key_val(UCRP_ADD_BASE,UCRP_ADD_LEN,-1);
 rot_val = (ucrp_key_val(UCRP_ROT_BASE,UCRP_ROT_LEN,-1) & 7);

/* copy to destination buffer */
 for(pos = 0; pos < len; ++pos) {
    *(dst + pos) = *(src + pos);
 }

/* */ 
/* int hlen = 2; */
 int hlen = 64;
 int hnum;
/* */ 
 for(hnum = 0; hnum < hlen; ++hnum) {
    u_char hch;    
    hch = ucrp_passwd[hnum];
    if((hch & 1) != 0) {
	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    tab[tpos] = (tab[tpos] ^ xor_val);
	}
    }

    if((hch & 2) != 0) {
	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    tab[tpos] = tab[tpos] + add_val;
	}
    }

    if((hch & 4) != 0) {
	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    tab[tpos] = (tab[tpos] >> rot_val) | (tab[tpos] << (8 - rot_val));
	}
    }

    hch >>= 4;
    if((hch & 1) != 0) {
	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    tab[tpos] = (tab[tpos] ^ xor_val);
	}
    }

    if((hch & 2) != 0) {
	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    tab[tpos] = tab[tpos] + add_val;
	}
    }

    if((hch & 4) != 0) {
	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    tab[tpos] = (tab[tpos] >> rot_val) | (tab[tpos] << (8 - rot_val));
	}
    }
 }

#ifdef __UCRP_TAB_DEBUG__
    {
	ucrp_printf(UMSG_TAB_DE_END);

        int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    ucrp_printf(UMSG_SP);
	    ucrp_printf(UMSG_02X, tab[tpos]);
	}	
	ucrp_printf(UMSG_CRNL);
    }
#endif 						/* __UCRP_TAB_DEBUG__ */

/* */
 for(hnum = hlen - 1; hnum >= 0; --hnum) {
    u_char hch;    
    hch = (ucrp_passwd[hnum] >> 4);

    if((hch & 4) != 0) {
	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    tab[tpos] = (tab[tpos] << rot_val) | (tab[tpos] >> (8 - rot_val));
	}
    }

    if((hch & 2) != 0) {
	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    tab[tpos] = tab[tpos] - add_val;
	}
    }

    if((hch & 1) != 0) {
	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    tab[tpos] = (tab[tpos] ^ xor_val);
	}
    }

#ifdef __UCRP_TAB_DEBUG__
    {
	ucrp_printf(UMSG_TAB_DE, hnum);

	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    ucrp_printf(UMSG_SP);
	    ucrp_printf(UMSG_02X,tab[tpos]);
	}	
        ucrp_printf(UMSG_CRNL);
    }
#endif 						/* __UCRP_TAB_DEBUG__ */

    u_char rev[256];
    for(pos = 0; pos < 256; ++pos) {
	u_char ch;
	ch = tab[pos];
        rev[ch] = pos;
    }

    for(pos = 0; pos < len; ++pos) {
	u_char ch;
	ch = *(dst + pos);
	ch = rev[ch];
	*(dst + pos) = ch;
    }

    hch = ucrp_passwd[hnum];

    if((hch & 4) != 0) {
	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    tab[tpos] = (tab[tpos] << rot_val) | (tab[tpos] >> (8 - rot_val));
	}
    }

    if((hch & 2) != 0) {
	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    tab[tpos] = tab[tpos] - add_val;
	}
    }

    if((hch & 1) != 0) {
	int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    tab[tpos] = (tab[tpos] ^ xor_val);
	}
    }

#ifdef __UCRP_TAB_DEBUG__
    {
	ucrp_printf(UMSG_TAB_DE, hnum);

        int tpos;
	for(tpos = 0; tpos < 256; ++tpos) {
	    ucrp_printf(UMSG_SP);
	    ucrp_printf(UMSG_02X, tab[tpos]);
	}	
	ucrp_printf(UMSG_CRNL);
    }
#endif 						/* __UCRP_TAB_DEBUG__ */

    for(pos = 0; pos < 256; ++pos) {
	u_char ch;
	ch = tab[pos];
        rev[ch] = pos;
    }

    for(pos = 0; pos < len; ++pos) {
	u_char ch;
	ch = *(dst + pos);
	ch = rev[ch];
	*(dst + pos) = ch;
    }
 }

 return(len);
}
#endif 							/* __UCRP_TAB_ENABLE__ */

/* */
extern void nand_calculate_ecc (const u_char *dat, u_char *ecc_code);
extern int nand_correct_data (u_char *dat, u_char *read_ecc, u_char *calc_ecc);

#ifdef __UCRP_ECC_ENABLE__
//#define NO_ECC
int ucrp_ecc_en(u_char * dst, u_char * src, int len)
{
#ifdef NO_ECC
 memcpy(dst,src,len);
 return(len);
#else
 u_char ecc[3];				/* calculated ecc */
 int dpos;				/* destination position */
 int spos; 				/* source position */
/* */
 dpos = 0;				/* start destination position */
/* */
 for(spos = 0; spos < len;) {
    int cnt;
    if(spos + 256 <= len) {
/* full block */
	nand_calculate_ecc(src + spos, ecc);	/* calculate ecc */
	cnt = 256;			/* source block size */
    } else {
/* partitional block */
	cnt = len - spos;		/* block size */
	u_char tmp[256];		/* temp buffer */
	int pos;			/* buffer position */
	for(pos = 0; pos < cnt; ++pos) {   /* copy to temp buffer */
	    tmp[pos] = *(src + spos + pos);
	}

	while(pos < 256) {		/* fill tail */
	    tmp[pos++] = 0xFF;
	}
	nand_calculate_ecc(tmp, ecc);	/* calculate ecc */
    }

/* copy data to destination buffer */
    int pos;				/* byte number */
    for(pos = 0; pos < cnt; ++pos) {	
	*(dst + dpos) = *(src + spos);	/* copy byte */
	 dpos += 1;			/* destination position */
  	 spos += 1;			/* source position */
    }

/* copy ecc to destination buffer */
    *(dst + dpos++) = ecc[0];		/* ecc 0 */
    *(dst + dpos++) = ecc[1];		/* ecc 1 */
    *(dst + dpos++) = ecc[2];		/* ecc 2 */

/* */
/* fprintf(stdout, "%d\n", dpos); */
 }
 return(dpos);
#endif								/* NO_ECC */
}
#endif 							/* __UCRP_ECC_ENABLE__ */

/* ecc decode */

#ifdef __UCRP_ECC_ENABLE__
int ucrp_ecc_de(u_char * dst, u_char * src, int len)
{
#ifdef NO_ECC
 memcpy(dst,src,len);
 return(len);
#else
 u_char calc[3];
 u_char * ecc;				/* readded ecc */
 int dpos;				/* destination position */
 int spos; 				/* source position */

/* */
 dpos = 0;				/* start destination position  */
/* */
 for(spos = 0; spos < len;) {
    int cnt;
    if(spos + 256 + 3 <= len) {
/* full block */
	ecc = src + spos + 256;			/* readed ecc */
	nand_calculate_ecc(src + spos, calc);	/* claculate ecc */	
	nand_correct_data(src + spos, ecc, calc); /* correct data */

	cnt = 256;				/* bytes count */	

	int pos;				/* byte offset */
	for(pos = 0; pos < cnt; ++pos) {

	    *(dst + dpos) = *(src + spos);	/* copy byte */
	     dpos += 1;				/* move destination position */
	     spos += 1;				/* move source position */
	}

	spos += 3;				/* skip ecc code */
    } else {
	cnt = len - spos - 3;			/* bytes */
	u_char tmp[256];			/* temp buffer */
	
	int pos;				/* byte offset */
	for(pos = 0; pos < cnt; ++pos) {	/* copy to temp buffer */
	    tmp[pos] = *(src + spos + pos);
	}
	
	ecc = src + spos + pos;			/* readed ecc */

	while(pos < 256) {			/* fill tail */
	    tmp[pos++] = 0xFF;
	}

	nand_calculate_ecc(tmp, calc);		/* calculate ecc */
	nand_correct_data(tmp, ecc, calc);	/* correct data */

/* copy to destination buffer */	
	for(pos = 0; pos < cnt; ++pos) {
	    *(dst + dpos) = *(tmp + pos);	/* copy bytes */
	    dpos += 1;			/* next destinatiuon position */
	    spos += 1;			/* next source position */
	}

	spos += 3;			/* skip ecc */
    }

/* fprintf(stdout, "%d\n", spos); */
 }
/* */
 return(dpos);				/* return total bytes */
#endif 							/* NO_ECC */
}
#endif 	

/* create dbin full name */
/* num = 0 - /dbin/<file name>, num = 1 - /usr/dbin/<file name>  
fcut - file cut flag
 return - dname length without terminating character
*/

int ucrp_dbin_name(int num, char * dname, int dlen, char * pfile, int * fcut)
{
/* check input parameters */
 if(
    (dname == 0) || 			/* null output buffer */
    (dlen <= 0) || 			/* null output buffer length */
    (pfile == 0)			/* null password file name length */
 ) {
/* name buffer not defined */
    return(0);
 }

 if(*(pfile + 0) == '\0') {		/* null passwd file */
    *(dname+0) = '\0';			/* null password file name */
    return(0);				/* file name length */
 }

/* extract key file name */
 char * fnam;				/* file name */
 char * pstr; 				/* temporary variable */
 fnam = pfile;				/* set to file start string */
 pstr = fnam;			
 while(*pstr != '\0') {
/* find string separator or string terminator */
    while(*pstr != '\0' && *pstr != '/'){ /* search name separator */
        pstr++;				/* next character in string */
    }

    if(*pstr == '/') {
    /* string separator found */
        pstr++;				/* move to next string character */
        fnam = pstr;			/* reset file name */
    }
 }

 if(*fnam == '\0') {			/* not valid pfile format */
    *(dname+0) = '\0';			/* null password file name */
    return(0);				/* -> 0 */
 }
 
/* form file name */
 char *pref;				/* file name prefix */
 if(num == 0) {			
    pref = "/dbin/";			/* 0 -> /dbin/<file name> */
 } else {
    pref = "/usr/dbin/";		/* 1 -> /usr/dbin/<file name> */
 }

 if(fcut != 0) {
/* not null string cut flag buffer */
    int plen;				/* file prefix name length */
    int flen;				/* file name length */

/* calculate prefix length */
    plen = 0;    			/* start prefix length */
    while(*(pref + plen) != '\0') {	/* while not string terminator */
	plen++;				/* calculate prefix length */
    }

/* calculate file name length */
    flen = 0;    			/* start file name length */
    while(*(fnam + flen) != '\0') {	/* while not string terminator */
	flen++;				/* calculate file length length */
    }

    if((flen + plen + 1) > dlen) {
	*fcut = 1;			/* set cut flag */
    } else {
	*fcut = 0;			/* clear cut flag */
    }
 }

 int len;				/* file name length */
 len = snprintf(
    dname, 				/* buffer */
    dlen, 				/* buffer length */
    "%s%s", 				/* format */
    pref,				/* file name */
    fnam				/* file name */
 );
 return(len);				/* return fil name length */
}







#include <sched.h>

static int ucrp_argc = 0;		/* user argument count */
static char **ucrp_args = 0;		/* argument string */
static char ucrp_stack[1024 * 128];	/* program stack */


/* print signal name */

static char * ucrp_sig_name(siginfo_t * sinfo, char * sname, int ssize)
{
 static struct {
    int num;				/* signal number */
    char * name;			/* signal name */
 } sginfo[] = {
    { SIGHUP   , "1)SIGHUP - Hangup" },
    { SIGINT   , "2)SIGINT - Interrupt" },
    { SIGQUIT  , "3)SIGQUIT - Quit" },
    { SIGILL   , "4)SIGILL - Illegal instruction" },
    { SIGTRAP  , "5)SIGTRAP - trap" },
    { SIGABRT  , "6)SIGABRT - abort" },
    { SIGBUS   , "7)SIGBUS - buss error" },
    { SIGFPE   , "8)SIGFPE - floating point exeption" },
/* not processed signal */ 
    { SIGKILL  , "9)SIGKILL - kill" },
    { SIGUSR1  , "10)SIGUSR1 - user signal 1" },
    { SIGSEGV  , "11)SIGSEGV - segmetation violation" },
    { SIGUSR2  , "12)SIGUSR2 - user signal 2" },
    { SIGPIPE  , "13)SIGPIPE - pipe" },
    { SIGALRM  , "14)SIGALRM - alarm" },
    { SIGTERM  , "15)SIGTERM - term" },
    { SIGSTKFLT, "16)SIGSTKFLT - stack failt" },
/* 17-31 */
    { SIGCHLD  , "17)SIGCHLD - children" },
    { SIGCONT  , "18)SIGCONT - continue" },
    { SIGSTOP  , "19)SIGSTOP - stop" },
    { SIGTSTP  , "20)SIGTSTP - terminal stop, terminal command" },
    { SIGTTIN  , "21)SIGTTIN - terminal read" },
    { SIGTTOU  , "22)SIGTTOU - terminal weite" },
    { SIGURG   , "23)SIGURG - urg" },	/*  */
    { SIGXCPU  , "24)SIGXCPU - cpu limit exceeded" },
/* */
    { SIGXFSZ  , "25)SIGXFSZ - file size exceeded" },
    { SIGVTALRM, "26)SIGVTALRM - virtual alarm clock" },
    { SIGPROF  , "27)SIGPROF - profilling alarm clock" },
    { SIGWINCH , "28)SIGWINCH - window size changed" },
    { SIGIO    , "29)SIGIO - I/O" },
    { SIGPWR   , "30)SIGPWR - power failure restart" },
    { SIGSYS   , "31)SIGSYS - bad system call" }
 };

 char * sptr;				/* signal name pointer */
 if(sinfo->si_signo >= 1 && sinfo->si_signo <= 31) {
    if(sginfo[sinfo->si_signo-1].num == sinfo->si_signo) {
/* print signal description */
	sptr = sginfo[sinfo->si_signo-1].name;
    } else {
	return(0);
    }
 } else {
    return(0);
 }

 if(sname == 0 || ssize <= 1) {
    return(sptr);
 }

 snprintf(
    sname,				/* signal name buffer */
    ssize,				/* buffer size */
    "%s",				/* format */
    sptr
 );    
 
 return(sname);				/* return buffer pointer */
} 
 
/* print signal information */

static int ucrp_sig_info(siginfo_t * sinfo, void * sptr)
{
 if((sinfo == 0) || (sptr == 0)) {
/* null pointers -> print error message and exit */
    ucrp_error("Bad signal call sinfo=0x%x , sptr=0x%x\n",
	sinfo	,		/* signal pointer */
	sptr			/* */
    );
    return(0);
 }

 char sname[32];
 if(ucrp_sig_name(sinfo,sname,sizeof(sname)) != 0) {
/* print signal description */
    ucrp_printf("%s\n", sname);
 }
 
/* print signal description */
 ucrp_printf(
    "Signal num {%d}, errno {%d}, code {%d}\n"
    "pid {%d}, uid {%d}, status {%d}, utime {%d}, stime {%d}\n"
    "value {%d}, int {%d}, ptr {%d}, addr {%d}, band {%d}, fd {%d}\n"
    "sptr {%x}\n",
/* */
    sinfo->si_signo	,	/* signal number */
    sinfo->si_errno	,	/* errno code */
    sinfo->si_code 	,	/* code */
/* */
    sinfo->si_pid 	,	/* process id */
    sinfo->si_uid	,	/* user id */
    sinfo->si_status	,	/* */
    sinfo->si_utime	,	/* user time */
    sinfo->si_stime	,	/* system time */
/* */
    sinfo->si_value	,	/* signal vale */
    sinfo->si_int 	,	/* int */
    sinfo->si_ptr	,	/* ptr */
    sinfo->si_addr	,	/* addr */
    sinfo->si_band	,	/* */
    sinfo->si_fd	,	/* file descriptor */
    sptr			/* */
 );

/* */
 return(1);	
}

/* log signal */
int ucrp_sig_log(siginfo_t * sinfo, void * sptr)
{
 if(sinfo == 0) {			/* signal description null pointer */	
    return(0);
 } 

 char * lname = "/var/log/ucrpsdump";	/* log file name */
 FILE * flog;				/* log file */

/* */
 int rvl;				/* return code */
/* */
 rvl = 1;				/* start return code */

 flog = fopen(lname, "r+b");		/* open log file  */
 if(flog == 0) {
    flog = fopen(lname, "w");		/* open log file  */
    if(flog == 0) {			/* open file in write mode error */
	return(0);
    }
 } else {
/* file opened in read mode -> set to file end */
    if(fseek(flog, 0, SEEK_END) < 0) {
	rvl = 0;
    }
 }

 char buf[32];    			/* signal name buffer */
 if(ucrp_sig_name(sinfo,buf,sizeof(buf)) <= 0) {
    fprintf(flog, "%d\n", sinfo->si_signo);
 } else {
    fprintf(flog, "%s\n", buf);
 }
    
 if(fclose(flog) < 0) {
    rvl = 0;
 }

 if(rvl == 0) {
    return(0);
 }
 return(1);
}

/* terminate signal received */

volatile int kill_link = 0;
static void ucrp_sig_term_ext(int sig, siginfo_t * sinfo, void * sptr)
{
 if(kill_link == 0) {
    kill_link = 1;			/* received signal */
    ucrp_sig_info(sinfo,sptr);		/* print signal description */
    ucrp_sig_log(sinfo,sptr);		/* log signal */
 } else {
    kill_link += 1;			/* received signal */
 }
}

volatile u_int8_t debug_alrm = 1;	/* print debug note in alarm handler */
volatile u_int8_t 
sig_alrm = 0;		/* > 1, exit flag from select loop */
static void ucrp_sig_alarm_ext(int sig, siginfo_t * sinfo, void * sptr)
{
 if(sig_alrm == 0) {
    if(debug_alrm > 0) {
/* debug alarm signals */
	ucrp_sig_info(sinfo,sptr);	/* print signal description */
	ucrp_sig_log(sinfo,sptr);	/* log signal */
    }
 }
 sig_alrm += 1;			/* > 1, exit flag from select loop */
}

/* sigpipe processing function  */
volatile int ucrp_sig_pipe_flag = 0;
static void ucrp_sig_pipe_ext(int sig, siginfo_t * sinfo, void * sptr)
{
 ucrp_sig_info(sinfo,sptr);		/* print signal description */
 ucrp_sig_log(sinfo,sptr);		/* log signal */
 ucrp_sig_pipe_flag = 1;
/* ==== TODO ==== */
}


/* SIGTERM/SIGINT */
volatile int sig_chld_flag = 0;
static void ucrp_sig_chld_ext(int sig, siginfo_t * sinfo, void * sptr)
{
 ucrp_sig_info(sinfo,sptr);		/* print signal description */
 ucrp_sig_log(sinfo,sptr);		/* log signal */
 sig_chld_flag = 1;
/* ==== TODO ==== */
}


/* bad signal received */
static void ucrp_bad_signal_ext(int sig, siginfo_t * sinfo, void * sptr)
{
 ucrp_sig_info(sinfo,sptr);		/* print signal description */
 ucrp_sig_log(sinfo,sptr);		/* log signal */
 exit(1);		
/* ==== TODO ==== kill_link = 1 */
}


int ucrp_signal(int snum, void (*actn)(int, siginfo_t *, void *)) 
{
 if(
    (snum == SIGKILL) || 		/* unconditionall kill */
    (snum == SIGSTOP)			/* stop process */
 ) {
/* not processed signals */
    return(0);
 } 

/* signal action structure */
 struct sigaction sact;			/* signal action */
 sact.sa_handler = 0;			/* signal handler */
 sact.sa_sigaction = actn;		/* signal extended handler */
 sact.sa_restorer = 0;			/* restore function */

/* signal process flags */
 sact.sa_flags = (
    SA_SIGINFO | 			/* signal handler requiry 3 arguments */
    SA_RESTART | 			/* BSD compatible */
    SA_NOMASK				/* not mask this signal */
 );

/* clear blocked signal mask */
 if(sigemptyset(&sact.sa_mask) < 0) {	/* clear mask error */
    ucrp_error("Clear nonblocked signals mask error\n");
    return(0);
 }

/* blocked signals mask */ 
 if(
    (sigaddset(&sact.sa_mask, SIGHUP)  < 0) || 	/* SIGHUP */
    (sigaddset(&sact.sa_mask, SIGINT)  < 0) ||	/* INT */
    (sigaddset(&sact.sa_mask, SIGTERM) < 0) ||	/* TERM */
    (sigaddset(&sact.sa_mask, SIGCHLD) < 0) ||	/* CHLD */
    (sigaddset(&sact.sa_mask, SIGUSR2) < 0)   	/* USR2 */
 ) {
/* add signal in mask error */
    ucrp_error("Set nonblocked signals mask %x error\n", sact.sa_mask);
    return(0);
 }

/* set signal handler */
 if(sigaction(snum, &sact, 0) < 0) {
    ucrp_error("Set signal %d handler error\n");
    return(0);
 }

 return(1);
}



//#include <stropts.h>
int main(int argc, char * args[])
{
 extern int ucrp_main(void *);		/* clone function */
 int status;
 int pid;

/* */
 int rvl;
/* */
 rvl = 1; 
 ucrp_argc = argc;			/* save argument count */
 ucrp_args = args;			/* save argument string */
/* create clone with new stack */
 pid = clone(ucrp_main, ucrp_stack + sizeof(ucrp_stack) -4 , CLONE_VFORK | CLONE_DETACHED, (void *) UMSG_EMP);
 status = 0;				/* clear program exit status */
 wait(& status);			/* wait program termination */
 if(status == 0) {			
    rvl = 0;				/* clear program return code */
 }
 exit(rvl);				/* return */
}  

/* clone function */

int ucrp_main(void *)
{

 ucrp_init();

// search in input args help request ///////////////////////////////////////// 
 int argn;

 if(ucrp_argc >= 1) {
    if( (*(ucrp_args[0] + 0) == '.') || (*(ucrp_args[0] + 1) == '/') ) {
	ucrp_local = 1;			/* local path */
    } else {
	ucrp_local = 0;			/* not local path */
    } 
 }

/* */
 u_int16_t ecmd = 0;
 int16_t argd;
 int rvl; 
/* */
 rvl = 1;

/* 1 - 16 */
 int inum;				/* signal definition index */	
 inum = 0;				/* start index */
 while(1) {
    struct {
	int snum;				/* signal number */
	void (*sfun)(int, siginfo_t *, void *); /* signal function */
    } sigdef[] = {
	{ SIGHUP   , ucrp_bad_signal_ext },	/* 1 - Hangup */
	{ SIGINT   , ucrp_bad_signal_ext },	/* 2 - Interrupt */
	{ SIGQUIT  , ucrp_bad_signal_ext },	/* 3 - Quit */
	{ SIGILL   , ucrp_bad_signal_ext },	/* 4 - Illegal instruction */

	{ SIGTRAP  , ucrp_bad_signal_ext },	/* 5 - trap */
	{ SIGABRT  , ucrp_bad_signal_ext },	/* 6 - abort */
	{ SIGBUS   , ucrp_bad_signal_ext },	/* 7 - buss error */
	{ SIGFPE   , ucrp_bad_signal_ext },	/* 8 - floating point exeption */

/* not processed signal */ 
/*	{ SIGKILL  , ucrp_bad_signal_ext }, */	/* 9 - kill */
	{ SIGUSR1  , ucrp_bad_signal_ext },	/* 10 - user signal 1 */
	{ SIGSEGV  , ucrp_bad_signal_ext },	/* 11 - segmetation violation */
	{ SIGUSR2  , ucrp_bad_signal_ext },	/* 12 - user signal 2 */
 
	{ SIGPIPE  , ucrp_sig_pipe_ext },	/* 13 - pipe */
	{ SIGALRM  , ucrp_sig_alarm_ext },	/* 14 - alarm */
	{ SIGTERM  , ucrp_sig_term_ext },	/* 15 - term */
	{ SIGSTKFLT, ucrp_bad_signal_ext },	/* 16 - stack failt */
/* 17-31 */
	{ SIGCHLD  , ucrp_sig_chld_ext },	/* 17 - children */
	{ SIGCONT  , ucrp_bad_signal_ext },	/* 18 - continue */
/* not processed signal */ 
/*	{ SIGSTOP  , ucrp_bad_signal_ext }, */	/* 19 - stop */
	{ SIGTSTP  , ucrp_bad_signal_ext },	/* 20 - terminal stop, terminal command */

	{ SIGTTIN  , ucrp_bad_signal_ext },	/* 21 - terminal read */
	{ SIGTTOU  , ucrp_bad_signal_ext },	/* 22 - terminal weite */
	{ SIGURG   , ucrp_bad_signal_ext },	/* 23 - urg */
	{ SIGXCPU  , ucrp_bad_signal_ext },	/* 24 - cpu limit exceeded */

	{ SIGXFSZ  , ucrp_bad_signal_ext },	/* 25 - file size exceeded */
	{ SIGVTALRM, ucrp_bad_signal_ext },	/* 26 - virtual alarm clock */
	{ SIGPROF  , ucrp_bad_signal_ext },	/* 27 - profilling alarm clock */
	{ SIGWINCH , ucrp_bad_signal_ext },	/* 28 - window size changed */

	{ SIGIO    , ucrp_bad_signal_ext },	/* 29 - I/O */
	{ SIGPWR   , ucrp_bad_signal_ext },	/* 30 - power failure restart */
	{ SIGSYS   , ucrp_bad_signal_ext },	/* 31 - bad system call */
/* 32 */
/* 33 */
/* 34 */
	{ 0, 0 }
    };

    int snum;				/* signal number */
    snum = sigdef[inum].snum;		/* read signal number */
    if(snum == 0) {			/* signal array terminator */
	{ break; }			/* terminate loop */
    }
    
    /* set signal process function */
    if(ucrp_signal(snum,sigdef[inum].sfun) == 0) {
    /* set signal error -> clear return code */
        rvl = 0;
    }
    inum += 1;				/* next index in signal description */
 }

/* 35 - 64 */
 {
    int snum;				/* signal number */
    for(snum = SIGRTMIN; snum <	SIGRTMAX; ++snum) {	
    /* set run time signals 35 - 64 */
	if(ucrp_signal(snum,ucrp_bad_signal_ext) == 0) {
	/* set signal error -> clear return code */
	    rvl = 0;
	}
    }
 }


/* */
 for(argn = 1; argn < ucrp_argc; argn += argd) {
    u_int16_t argu;			/* unknown argument flag */
    argd = 1;				/* processed arguments */
    argu = 0;				/* */
    if(strcmp(ucrp_args[argn], "--encrypt") == 0) {
	    ucrp_cmd |= UCRP_ENCRYPT;	/* encrypt */
    } else
    if(strcmp(ucrp_args[argn], "--decrypt") == 0) {
	    ucrp_cmd |= UCRP_DECRYPT;	/* decrypt */
    } else
    if(strcmp(ucrp_args[argn], "--quiet") == 0) {
	ucrp_quiet = 1;			/* quiet mode */
    } else
    if((strcmp(ucrp_args[argn], "--current-dir") == 0) ||
       (strcmp(ucrp_args[argn], "--change-dir") == 0)
    ) {
	if(argn + 1 >= ucrp_argc) {
	    ucrp_error("Option --current-dir requery argument\n"); 
	    { break; }				/* */
	} else {
	    snprintf(ucrp_cdir, sizeof(ucrp_cdir), 
	    UMSG_PS, ucrp_args[argn+1]);
	    argd = 2;
	}
    } else 
    if(strcmp(ucrp_args[argn], "--block-size") == 0) {
/* block size */
	if(argn + 1 >= ucrp_argc) {
	    ucrp_error("Option --block-size requery argument\n"); /* print error message */
	    { break; }				/* exit */
	} else {
	    int valu;				/* numeric argument */
	    char * sstr;			/* text string */
	    sstr = ucrp_args[argn+1];		/* read text string from command args */
	    if(sstr != 0) {
		if((*sstr == 'x') || (*sstr == 'X')) {
		/* read number from command ucrp_args */
		    char * endptr;
		    valu = strtoul(sstr + 1, &endptr, 16);
		} else 
		if(
		       (*sstr == '0') && 
		    ((*(sstr + 1) == 'x') || (*(sstr + 1) == 'X'))
		) {
		/* read number from command ucrp_args */
		    char * endptr;
		    valu = strtoul(sstr + 2, &endptr, 16);
		} else {
		    valu = atoi(sstr);	/* read number from command ucrp_args */
		}
	    } else {
		valu = 256;		/* null pointer */
	    }

	    if(valu < 256) {		/* set value to low limit */
		valu = 256; 			
	    }

	    /* source buffer size */
	    ucrp_src_buf_size = ((valu + 255) / 256) * 256;

	    /* destination buffer size */
	    ucrp_dst_buf_size = 
		ucrp_src_buf_size + (((ucrp_src_buf_size + 255) / 256) * 3);

	    argd = 2;
	}
    } else
    if(strcmp(ucrp_args[argn], "--passwd") == 0) {
	    if(argn + 1 >= ucrp_argc) {
	/* print args to history & print error message */
		ucrp_error("Option --passwd requery argument\n"); 
		{ break; }			
	    } else {
		if(ucrp_passwd[0] == '\0') {
	    /* read password */
		    snprintf(ucrp_passwd, sizeof(ucrp_passwd), 
		    UMSG_PS, ucrp_args[argn+1]);
	    	    argd = 2;
	        } else {
		/* password file */
		    snprintf(ucrp_pfile, sizeof(ucrp_pfile), 
		    UMSG_PS, ucrp_args[argn+1]);
	    	    argd = 2;
		}
	    }
    } else
    if(strcmp(ucrp_args[argn], "--info") == 0) {
	    ucrp_cmd |= UCRP_INFO;
    } else
    if(strcmp(ucrp_args[argn], "--hide-passwd") == 0) {
    	    ucrp_hide_passwd = 1;	/* hide passwd */
    } else
    if(strcmp(ucrp_args[argn], "--help") == 0) {
	ecmd = UCRP_HELP;		/* print usage message and exit */
	{ break; }
    } else
    if(strcmp(ucrp_args[argn], "--license") == 0) {
	ecmd = UCRP_LIC;
	{ break; }
    } else
    if(strcmp(ucrp_args[argn], "--license-ru") == 0) {
	ecmd = UCRP_LICRU;
	{ break; }
    } else
    if(strcmp(ucrp_args[argn], "--version") == 0) {
	ecmd = UCRP_VERSION;		/* print version & exit */
	{ break; }			
    } else
    if(strcmp(ucrp_args[argn], "--todo") == 0) {
	ecmd = UCRP_TODO;		/* print todo note & exit */
	{ break; }
    } else
    if(strcmp(ucrp_args[argn], "--changelog") == 0) {
	ecmd = UCRP_CHANGELOG;		/* print change log & exit */
	{ break; }
    } else
    if(strcmp(ucrp_args[argn], "--man") == 0) {
	ecmd = UCRP_MAN;		/* print man page and exit */
	{ break; }
    } else
     {
	if(argn + 1 == ucrp_argc - 1) {
	    snprintf(ucrp_ifile, sizeof(ucrp_ifile), UMSG_PS, ucrp_args[argn]);
	    snprintf(ucrp_ofile, sizeof(ucrp_ofile), UMSG_PS, ucrp_args[argn+1]);
	    argd = 2;
	} else
	if(argn == ucrp_argc - 1) {
	    snprintf(ucrp_ifile, sizeof(ucrp_ifile), UMSG_PS, ucrp_args[argn]);
	}
    }

    if(argu == 1) {
/* unknown argument -> print error message and exit */
	ucrp_error("Unknown option {%s}\n", ucrp_args[argn]);
	exit(1);
    }
 }

 if(argn < ucrp_argc) {
    argn += 1;
 }

/* read current working dir */
 getcwd(ucrp_pdir, sizeof(ucrp_pdir));	

 /* current dirrectory */
 if(strlen(ucrp_cdir) > 0) {
    ucrp_printf("current dir:{%s}\n", ucrp_cdir);
    /* read current working dirrectory */
    chdir(ucrp_cdir);				/* change dirrectory */
 }

 {
/* print history & print error message */	    
    char * hargs[128];			/* argument number */
    int16_t hargc;			/* destination argument count */
    int16_t sargc;			/* source argument number */
    
    hargc = 0;
    for(sargc = 0; sargc < argn; ) {
	if(strcmp(ucrp_args[sargc], "--passwd") != 0) {
	    if(hargc < 128) {
		hargs[hargc] = ucrp_args[sargc];
	    } else {
		break;
	    } 
	    hargc += 1;			/* next destination command line argument */
	    sargc += 1;			/* next source command line argument */
	} else {
/* skip passwd command line argument */
	    sargc += 2;
	}
    }

 }


 if(ecmd == 0) {
    /* input file name */
    if(strlen(ucrp_ifile) > 0) {
	ucrp_printf("input file:{%s}\n", ucrp_ifile);
    }
    /* output file name */
    if(strlen(ucrp_ofile) > 0) {
	ucrp_printf("output file:{%s}\n", ucrp_ofile);
    }
    if((ucrp_src_buf_size != 0) && (ucrp_dst_buf_size != 0)) {
/* print source & destination block size */
/* print source block size in decimal and hexadecimal mode */
	ucrp_printf("src block size : %d {%x}\n", 
	    ucrp_src_buf_size, ucrp_src_buf_size);
/* print destination block size in decimal and hexadecimal mode */
	ucrp_printf("dst block size : %d {%x}\n", 
	    ucrp_dst_buf_size, ucrp_dst_buf_size);
    }
    ucrp_printf("cmd:");
    if((ucrp_cmd & UCRP_ENCRYPT) != 0) {		/* encrypt passwd  */
	ucrp_printf("{encrypt}");
    } else 
    if((ucrp_cmd & UCRP_DECRYPT) != 0) {		/* decrypt passwd */
	ucrp_printf("{decrypt}");
    } else 
    if((ucrp_cmd & UCRP_INFO) != 0) {		/* file info */
	ucrp_printf("{info}");
    }
    ucrp_printf("\n");
 }

/* */
 if(strlen(ucrp_passwd) > 0) {
/* not empty passwd */
    if(ucrp_hide_passwd == 0) {
	/* not hide passwd */
	ucrp_printf("NumLock, CapsLok sensitive\npasswd:[%s]\n", ucrp_passwd);
    }

    if(strcmp(ucrp_passwd, "request") == 0) {
    /* passwd request */

	int echo;			/* echo mode */
	if(ucrp_hide_passwd == 1) {
	    echo = 2;			/* print * as echo */
	} else {
	    echo = 1;			/* print entered character */
	}

	{
	    int pos;
	    for(pos = 0; pos < (int)sizeof(ucrp_passwd); ++pos) {
		ucrp_passwd[pos] = 0;
	    }
	    
	}

/* read passwd, echo *, wait CR */
	ucrp_select(ucrp_passwd,sizeof(ucrp_passwd), echo, 1);
    }
 }

 if(ecmd != 0) {
    if(ecmd == UCRP_HELP) {		/* print help usage & exit */
	ucrp_usage(0);
    } else
    if(ecmd == UCRP_LIC) {
	ucrp_license();
    } else
    if(ecmd == UCRP_LICRU) {
	ucrp_license_ru();
    } else
    if(ecmd == UCRP_VERSION) {		/* print version & exit */
	ucrp_version();
    } else
    if(ecmd == UCRP_TODO) {		/* print todo note & exit */
	ucrp_todo();
    } else
    if(ecmd == UCRP_CHANGELOG) {	/* print change log & exit */
	ucrp_changelog();
    } else
    if(ecmd == UCRP_MAN) {		/* print man page and exit */
	ucrp_man(0);
    } else
    {
	ucrp_error("Internal error (main.c)\n");
    }
    exit(1);
 }





 if(strlen(ucrp_passwd) > 0) {
/*    ucrp_printf("passwd:(%s)\n", ucrp_passwd); */
 }

/* */
 if(strlen(ucrp_pfile) > 0) {
    ucrp_printf("pfile:(%s)\n", ucrp_pfile);

/* read passwd file */
    ucrp_fi = fopen(ucrp_pfile, "r+b");
    if(ucrp_fi == 0) {
	ucrp_error("File [%s] 8 open error.\n", ucrp_pfile);
	return(0);
    }
   
    int pos;
    pos = strlen(ucrp_passwd);
    while(pos < (int) sizeof(ucrp_passwd)) {
	u_char ch;			/* readded ecc */
	ch = fgetc(ucrp_fi);
	if(feof(ucrp_fi) != 0) {
	    break;
	}
	ucrp_passwd[pos++] = ch;
    }

    if(pos < (int)sizeof(ucrp_passwd)) {
	ucrp_passwd[pos] = '\0';
    }
/* */    
    fclose(ucrp_fi);

/* */
    char * pnam;			/* last name */
    char * pstr; 			/* temporary variable */
    pnam = ucrp_pfile;			/* pfile */
    pstr = pnam;			
    while(*pstr != '\0') {
	/* find string separator or string terminator */
	while(*pstr != '\0' && *pstr != '/') {
	    pstr++;			/* next character in string */
	}
	if(*pstr == '/') {
	/* string separator */
	    pstr++;
	    pnam = pstr;
	}
    }

/* add file from /dbin catalog */
    char dbin[256];			/* string buffer */
    snprintf(				
	dbin, sizeof(dbin), 		/* string buffer & string name */
	"/dbin/%s", pnam		/* */
    );

    ucrp_fi = fopen(dbin, "r+b");	/* open */
    if(ucrp_fi != 0) {

	pos = strlen(ucrp_passwd);
	while(pos < (int) sizeof(ucrp_passwd)) {
	    u_char ch;			/* readded ecc */
	    ch = fgetc(ucrp_fi);
	    if(feof(ucrp_fi) != 0) {
		break;
	    }
	    ucrp_passwd[pos++] = ch;
	}

	if(pos < (int)sizeof(ucrp_passwd)) {
	    ucrp_passwd[pos] = '\0';
	}
	fclose(ucrp_fi);
    }

/* add file from /usr/dbin catalog */
    snprintf(				
	dbin, sizeof(dbin), 		/* string buffer & string name */
	"/usr/dbin/%s", pnam		/* */
    );

    ucrp_fi = fopen(dbin, "r+b");	/* open */
    if(ucrp_fi != 0) {

	pos = strlen(ucrp_passwd);
	while(pos < (int) sizeof(ucrp_passwd)) {
	    u_char ch;			/* readded ecc */
	    ch = fgetc(ucrp_fi);
	    if(feof(ucrp_fi) != 0) {
		break;
	    }
	    ucrp_passwd[pos++] = ch;
	}

	if(pos < (int)sizeof(ucrp_passwd)) {
	    ucrp_passwd[pos] = '\0';
	}
	fclose(ucrp_fi);
    }
 }


 if(strlen(ucrp_ifile) > 0) {
    ucrp_fi = fopen(ucrp_ifile, "r+b");
    if(ucrp_fi == 0) {
	ucrp_error("Input file [%s] 8 open error.\n", ucrp_ifile);
	return(0);
    }
 }

 if(strlen(ucrp_ofile) > 0) {
    ucrp_fo = fopen(ucrp_ofile, "w+b");
    if(ucrp_fo == 0) {
	ucrp_error("Input file [%s] 9 open error.\n", ucrp_ofile);
	return(0);
    }
 }

 ucrp_random_init();			/* init random */
 ucrp_comp_init();			/* init compatibylity buffer */
 ucrp_key_init();			/* init key buffer */

 if( ((ucrp_cmd & UCRP_INFO) != 0) || ((ucrp_cmd & UCRP_DECRYPT) != 0) ) {

    ucrp_comp_read();			/* read compatibylity buffer */
    ucrp_key_read();			/* read key buffer */
    ucrp_hash_init();

    if(ucrp_comp_check() != 1) {
	ucrp_error("Not valid input file\n");

	ucrp_random_close();		/* close random files */
 /* */
	if(ucrp_fi != 0) {
	    fclose(ucrp_fi);
	    ucrp_fi = 0;
	} 

 /* */
	if(ucrp_fo != 0) {
	    fclose(ucrp_fo);
	    ucrp_fo = 0;
	} 
	exit(1);
    }
 } else
 if( ((ucrp_cmd & UCRP_ENCRYPT) != 0) ) {

    if((ucrp_cmd & UCRP_ENCRYPT) != 0) {
/* encrypt -> disable XOR algorithm ==== TODO ==== */
	ucrp_comp(UCRP_XOR,0);
    }

    ucrp_comp_write();			/* read compatibylity buffer */
    ucrp_key_write();			/* read key buffer */
    ucrp_hash_init();
 }

 if((ucrp_src_buf_size == 0) || (ucrp_dst_buf_size == 0)) {
    ucrp_src_buf_size = UCRP_SRC_SIZE;	/* default source buffer size */
    ucrp_dst_buf_size = UCRP_BUF_SIZE;	/* default destination buffer */
 }

/* */
 int cflag;				

 cflag = 1;				/* cflag flag */

 if(ucrp_src == 0) {			/* buffer length */
    int blen;				/* buffer length */
    blen = ucrp_src_buf_size;		
/* max (ucrp_src_buf_size,ucrp_dst_buf_size) */
    if((int) ucrp_dst_buf_size > blen) {
	blen = ucrp_dst_buf_size;
    }
    ucrp_src = (u_char *) malloc(blen);	/* alloc source buffer */
    if(ucrp_src == 0) { 		/* memory allocation error */
	cflag = 0;
    }
 }

 if(ucrp_dst == 0) {			/* destination buffer */
    int blen;
    blen = ucrp_src_buf_size;		/* buffer length */
    /* max(ucrp_src_buf_size,ucrp_dst_buf_size) */
    if((int) ucrp_dst_buf_size > blen) {
	blen = ucrp_dst_buf_size;
    }

    ucrp_dst = (u_char *) malloc(blen);	/* malloc destination buffer */
    if(ucrp_dst == 0) {
	/* destination buffer alloc error */
	if(ucrp_src != 0) {
	    free(ucrp_src);		/* free source buffer */
	    ucrp_src = 0;		/* clear source buffer */
	}
	cflag = 0;			/* clear more flag */
    }
 }

/* */
 if(cflag == 1) {
    if((ucrp_cmd & UCRP_INFO) != 0) {
	ucrp_info();			/* print file info and exit */
    } else 
    if( ((ucrp_cmd & UCRP_ENCRYPT) != 0) || ((ucrp_cmd & UCRP_DECRYPT) != 0) ) {
/* encrypt & decrypt file */
	while(1) {
	/* read source buffer */
	    int cnt;			/* bytes to read */

	    cnt = ucrp_src_buf_size;	
#ifdef __UCRP_ECC_ENABLE__
	    if( ((ucrp_cmd & UCRP_DECRYPT) != 0) ) {
		if(ucrp_comp(UCRP_ECC,-1) != 0) {
	/* ecc enabled */
		    cnt = ucrp_dst_buf_size;
		}
	    }
#endif 							/* __UCRP_ECC_ENABLE__ */

	    /* read source buffer */
	    if(ucrp_src != 0) {
		cnt = ucrp_read(ucrp_src, cnt);
		if(cnt == 0) {			
		    break;
		}
	    }

	    static struct {
		char * name;		/* function name */
		int flag;		/* compatibility flag */
		int (*en)(u_char * dst, u_char * src, int cnt); /* encrypt flag */
	        int (*de)(u_char * dst, u_char * src, int cnt); /* decrypt flag */
	    } proc[] = {
#ifdef __UCRP_XOR_ENABLE__
		{"xor", UCRP_XOR, ucrp_xor_en, ucrp_xor_en}, /* XOR */	
#endif 							 /* __UCRP_XOR_ENABLE__ */
#ifdef __UCRP_XRE_ENABLE__
		{"xre", UCRP_XRE, ucrp_xre_en, ucrp_xre_en}, /* XRE */	
#endif 							 /* __UCRP_XRE_ENABLE__ */
#ifdef __UCRP_ADD_ENABLE__
		{"add", UCRP_ADD, ucrp_add_en, ucrp_add_de},	/* ADD */
#endif 							 /* __UCRP_ADD_ENABLE__ */
#ifdef __UCRP_ROT_ENABLE__
		{"rot", UCRP_ROT, ucrp_rot_en, ucrp_rot_de}, 	/* ROT */
#endif 							 /* __UCRP_ROT_ENABLE__ */
#ifdef __UCRP_TAB_ENABLE__
		{"tab", UCRP_TAB, ucrp_tab_en, ucrp_tab_de}, 	/* TAB */
#endif 							/* __UCRP_TAB_ENABLE__ */
#ifdef __UCRP_BTS_ENABLE__
		{"bts", UCRP_BTS, ucrp_bts_en, ucrp_bts_de},	/* BTS */
#endif							/* __UCRP_BTS_ENABLE__ */
#ifdef __UCRP_ECC_ENABLE__
		{"ecc", UCRP_ECC, ucrp_ecc_en, ucrp_ecc_de},	/* ECC */
#endif 							/* __UCRP_ECC_ENABLE__ */
		{0, 0, 0, 0},
	    }; 

	    u_char * buf[2] = {
		ucrp_src,		/* source buffer */
	        ucrp_dst		/* destination buffer */
	    };
	    int sbn = 0;		/* source buffer number */
	    int dbn = 1;		/* destination buffer number */
	
	    int fn;			/* function number */
	    int finc;			/* function increment value */
	    int fcnt;			/* functions count */

/* */
	    fcnt = 0;				/* function count */
	    while(proc[fcnt].name != 0) {	/* calculate function count */
		fcnt++;
	    }



	    fn = 0;
	    if((ucrp_cmd & UCRP_ENCRYPT) != 0) {
		finc = 1;
	    } else {
		while(proc[fn].name != 0) {
		    fn += 1;
		}
		fn -= 1;
		finc = -1;
	    }

	    while(fcnt-- > 0)  {
	    /* print function name */
		ucrp_printf("\n%d %s ",fn ,proc[fn].name);

		if(ucrp_comp(proc[fn].flag,-1) != 0) {
    		    ucrp_printf(".");

		    if((buf[sbn] != 0) && (buf[dbn] != 0)) {
			if((ucrp_cmd & UCRP_ENCRYPT) != 0) {
			/* encrypt */
			    cnt = proc[fn].en(buf[dbn], buf[sbn], cnt);
			} else {
			/* decrypt */
			    cnt = proc[fn].de(buf[dbn], buf[sbn], cnt);
			}
		    }

		    /* swap source and destination buffer */
		    sbn = ((sbn + 1) & 1);	/* next source buffer */
	    	    dbn = ((dbn + 1) & 1);	/* next destination buffer */

		    if(cnt > 0) {
	    		ucrp_printf(" Ok");
		    } else {
	    		ucrp_printf(" Fail");
		    }
		} else {
	    	    ucrp_printf(" Skipped");
		}

		fn += finc;			/* next function */
	    }
	    if(buf[sbn] != 0) {			/* write destination buffer */
		ucrp_write(buf[sbn], cnt);
	    }
	}
    }
 }

 /* */
 ucrp_random_close();

 /* */
 if(ucrp_fi != 0) {
    fclose(ucrp_fi);
    ucrp_fi = 0;
 } 

 /* */
 if(ucrp_fo != 0) {
    fclose(ucrp_fo);
    ucrp_fo = 0;
 } 


 if(strlen(ucrp_pdir) > 0) {
    chdir(ucrp_pdir);			/* restore current directory */
 }

 if(ucrp_src != 0) {
    free(ucrp_src);			/* free source buffer */
    ucrp_src = 0;			/* clear source buffer pointer */
 }

 if(ucrp_dst == 0) {
    free(ucrp_dst);			/* free destination buffer */
    ucrp_dst = 0;			/* clear destination buffer pointer */
 }
 return(rvl);
}

